/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "xkra.h"

FD_xkra *fdui;

int option_evaluation_form_modified_flag;
int fontsizes_modified_flag;

void option_evaluation_form_import_menu_cb(FL_OBJECT *ob, long data) 
{
int option_evaluation_form_import_menu_selection;

option_evaluation_form_import_menu_selection = fl_get_menu(ob);

/* if nothing selected, but mouse in menu, no action */
if(option_evaluation_form_import_menu_selection <= 0) return;

if(option_evaluation_form_import_menu_selection == IMPORT_DAVIEFF_OPTIONS)
	{
	if(! fl_show_question(\
	"This will import new options\nexisting data will be modified!\n\
	are you sure?",\
	3) )
		{
		return;
		}

	if(! import_and_evaluate_davieff_options_file() )
		{
/*		fl_show_alert("Cannot import davieff options file", "" , "", 1);*/
		return;
		}

	option_evaluation_form_modified_flag = 1;
	}/* end if IMPORT_DAVIEFF_OPTIONS */
} /* end function option_evaluation_form_import_menu_cb */


void option_evaluation_form_filter_input_field_cb(FL_OBJECT *ob, long data) 
{
show_options(SHOW_SAME_POSITION);
} /* end function option_evaluation_form_filter_input_field_cb */


void option_evaluation_form_filter_case_button_cb(FL_OBJECT *ob, long data) 
{
option_evaluation_form_filter_case_sensitive_flag = fl_get_button(ob);

if(option_evaluation_form_filter_case_sensitive_flag)
	{
	fl_set_object_label(ob, "CASE SENS");
	}
else
	{
	fl_set_object_label(ob, "IGNORE CASE");
	}

show_options(SHOW_SAME_POSITION);
} /* end function option_evaluation_form_filter_case_button_cb */


void option_evaluation_form_filter_clear_button_cb(FL_OBJECT *ob, long data) 
{
fl_set_input(fdui -> option_evaluation_form_filter_input_field, "");
show_options(SHOW_SAME_POSITION);
} /* end function option_evaluation_form_filter_clear_button_cb */


void option_evaluation_form_option_browser_cb(FL_OBJECT *ob, long data) 
{
} /* end function option_evaluation_form_option_browser_cb */


void option_evaluation_form_option_browser_double_cb(FL_OBJECT *ob, long data) 
{
} /* end function option_evaluation_form_option_browser_double_cb */


void option_evaluation_form_fontsize_up_button_cb(\
	FL_OBJECT *ob, long data)
{
int size;

fontsizes_modified_flag = 1;

if(option_evaluation_form_fontsize < 5)\
	option_evaluation_form_fontsize++;
size = integer_to_fontsize(option_evaluation_form_fontsize);
fl_set_browser_fontsize(fdui -> option_evaluation_form_option_browser, size);

}/* end function option_evaluation_form_fontsize_up_button_cb */


void option_evaluation_form_fontsize_down_button_cb(\
	FL_OBJECT *ob, long data)
{
int size;

fontsizes_modified_flag = 1;
if(option_evaluation_form_fontsize > 0)\
	option_evaluation_form_fontsize--;
size = integer_to_fontsize(option_evaluation_form_fontsize);

fl_set_browser_fontsize(fdui -> option_evaluation_form_option_browser, size);

}/* end function option_evaluation_form_fontsize_down_button_cb */


void option_evaluation_form_cancel_button_cb(FL_OBJECT *ob, long data) 
{
fl_hide_form(fdui -> option_evaluation_form);

if(fontsizes_modified_flag)
	{
	load_fontsizes();
	fontsizes_modified_flag = 0;
	}

if(! load_options() )
	{
	option_evaluation_form_shown_flag = 0;
	return;
	}

option_evaluation_form_shown_flag = 0;
} /* end function option_evaluation_form_cancel_button_cb */


void option_evaluation_form_accept_button_cb(FL_OBJECT *ob, long data) 
{
fl_hide_form(fdui -> option_evaluation_form);

if(fontsizes_modified_flag)
	{
	save_fontsizes();
	fontsizes_modified_flag = 0;
	}

if(! save_options() )
	{
	option_evaluation_form_shown_flag = 0;
	return ;
	}

option_evaluation_form_shown_flag = 0;
} /* end function option_evaluation_form_accept_button_cb */


