/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "xkra.h"

FD_xkra *fdui;

extern FD_xkra *fd_main_form;

int fontsizes_modified_flag;

void portfolio_form_value_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;
portfolio_form_value = atof(ptr);

}/* end function portfolio_form_value_input_field_cb */


void portfolio_form_cash_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

portfolio_form_cash = atof(ptr);

if(show_where_the_money_is_chart_shown_flag)
	{
	if(! show_where_the_money_is_chart() ) return;
	}

}/* end function portfolio_cash_input_field_cb */


void portfolio_form_market_filter_input_field_cb(FL_OBJECT *ob, long data)
{
show_items(SHOW_SAME_POSITION);
}/* end function portfolio_form_market_filter_input_field_cb */


void portfolio_form_market_filter_case_button_cb(FL_OBJECT *ob, long data)
{
portfolio_form_market_filter_case_sensitive_flag = fl_get_button(ob);

if(portfolio_form_market_filter_case_sensitive_flag)
	{
	fl_set_object_label(ob, "CASE SENS");
	}
else
	{
	fl_set_object_label(ob, "IGNORE CASE");
	}

show_items(SHOW_SAME_POSITION);
}/* end function portfolio_form_market_filter_case_button_cb */


void portfolio_form_market_filter_clear_button_cb(FL_OBJECT *ob, long data)
{
fl_set_input(fdui -> portfolio_form_market_filter_input_field, "");

show_items(SHOW_SAME_POSITION);
}/* end function portfolio_form_filter_market_clear_button_cb */


void portfolio_form_transaction_filter_input_field_cb(\
	FL_OBJECT *ob, long data)
{
show_transactions(SHOW_SAME_POSITION);
}/* end function portfolio_form_transaction_filter_input_field_cb */


void portfolio_form_transaction_filter_case_button_cb(\
	FL_OBJECT *ob, long data)
{
portfolio_form_transaction_filter_case_sensitive_flag = fl_get_button(ob);

if(portfolio_form_transaction_filter_case_sensitive_flag)
	{
	fl_set_object_label(ob, "CASE SENS");
	}
else
	{
	fl_set_object_label(ob, "IGNORE CASE");
	}

show_transactions(SHOW_SAME_POSITION);
}/* end function portfolio_form_filter_case_button_cb */


void portfolio_form_transaction_filter_clear_button_cb(FL_OBJECT *ob, long data)
{
fl_set_input(fdui -> portfolio_form_transaction_filter_input_field, "");

show_transactions(SHOW_SAME_POSITION);
}/* end function portfolio_form_transaction_filter_clear_button_cb */


void portfolio_form_show_owned_only_button_cb(FL_OBJECT *ob, long data)
{
portfolio_form_show_owned_only_flag =  fl_get_button(ob);
if(portfolio_form_show_owned_only_flag)
	{
	fl_set_object_label(ob, "SHOW OWNED");
	}
else
	{
	fl_set_object_label(ob, "SHOW ALL");
	}
show_items(SHOW_SAME_POSITION);
}/* end function portfolio_form_show_owned_only_button_cb */

 
void portfolio_form_market_browser_cb(FL_OBJECT *ob, long data)
{
int selected_line;

if(debug_flag)
	{
	fprintf(stdout, "portfolio_form_market_browser_cb():\n");
	}

selected_line = fl_get_browser(ob);
if(! selected_line) return;

/* maintain visible indication that line is selected with single click  */
fl_select_browser_line(\
	fdui -> portfolio_form_market_browser, abs(selected_line) );

}/* end function portfolio_form_market_browser_cb */


void portfolio_form_market_browser_double_cb(FL_OBJECT *ob, long data)
{
int selected_line;
int mouse_button;

if(debug_flag)
	{
	fprintf(stdout, "portfolio_form_market_browser_double_cb():\n");
	}

mouse_button = fl_mouse_button();

selected_line = fl_get_browser(ob);
if(! selected_line) return;

fl_select_browser_line(\
	fdui -> portfolio_form_market_browser, abs(selected_line) );

}/* end function portfolio_form_market_browser_double_cb */


void portfolio_form_transaction_browser_cb(FL_OBJECT *ob, long data)
{
int selected_line;

if(debug_flag)
	{
	fprintf(stdout, "portfolio_form_transaction_browser_cb():\n");
	}

}/* end function portfolio_form_transaction_browser_cb */


void portfolio_form_transaction_browser_double_cb(FL_OBJECT *ob, long data)
{
int selected_line;
int mouse_button;

if(debug_flag)
	{
	fprintf(stdout, "portfolio_form_transaction_browser_double_cb():\n");
	}

}/* end function portfolio_form_transaction_browser_double_cb */


void portfolio_form_browser_select_button_cb(FL_OBJECT *ob, long data)
{
int a;

a = fl_get_button(ob);

if(a)
	{
	select_portfolio_form_browser(TRANSACTION_BROWSER);
	fl_set_object_label(ob, "TRANSACTIONS");
	}
else
	{
	select_portfolio_form_browser(MARKET_BROWSER);
	fl_set_object_label(ob, "MARKET");
	}
}/* end function portfolio_form_browser_select_button_cb */


void portfolio_form_delete_expired_button_cb(FL_OBJECT *ob, long data)
	{
	fl_set_object_label(fdui -> portfolio_form_status_display,\
	"deleting expired entries, this may take a while");
	XSync(fl_get_display(), 0);

	if(! delete_expired_options() )
		{
		fl_show_alert("Could not delete all expired entries", "", "", 1);
		}

	fl_set_object_label(fdui -> portfolio_form_status_display,\
	"");
	XSync(fl_get_display(), 0);

	show_items(SHOW_TOP);
	}/* end function portfolio_form_delete_expired_button_cb */


void portfolio_form_sort_alpha_button_cb(FL_OBJECT *ob, long data)
{
fl_set_object_label(fdui -> portfolio_form_status_display,\
	"sorting alpha, this may take a while");
XSync(fl_get_display(), 0);

portfolio_form_sort_mode = SORT_ALPHA;
if(! sort_items(portfolio_form_sort_mode) ) return;

show_items(SHOW_SAME_POSITION);

fl_set_object_label(fdui -> portfolio_form_status_display, "");
XSync(fl_get_display(), 0);

}/* end function portfolio_form_sort_alpha_button_cb */


void portfolio_form_price_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

portfolio_form_item_price = atof(ptr);

if(portfolio_form_item_price < 0)
	{
	fl_set_focus_object(fd_main_form -> portfolio_form, ob);
	fl_show_alert("Illegal item price", ptr, "must be > 0", 1);
	}

}/* end function portfolio_form_price_input_field_cb */


void portfolio_form_buy_button_cb(FL_OBJECT *ob, long data)
{
int total_lines;
int s_line;
char *item;

total_lines = fl_get_browser_maxline(fdui -> portfolio_form_market_browser);
for(s_line = 1; s_line <= total_lines; s_line++)
	{
	if(fl_isselected_browser_line(\
	fdui -> portfolio_form_market_browser, s_line) )
		{
		portfolio_form_modified_flag = 1;
		item = (char *) line_to_item(s_line);
		if(item)
			{
			/*
			this updates account, taking into account share or option
			transaction costs, and warns if debet
			*/
			if(! buy_item(\
			item, portfolio_form_quantity, portfolio_form_item_price) )
				{
				fl_show_alert(\
				"Cannot add transaction to portfolio", "", "", 1);
				return;
				}

			/* 
			This updates quantity, price, also adds transaction to
			transaction list.
			*/
			if(!add_transaction_to_portfolio(\
			time(0), item,\
			portfolio_form_quantity, portfolio_form_item_price, BUY,\
			portfolio_form_cash) )
				{
				fl_show_alert(\
				"Cannot add transaction to portfolio", "", "", 1);
				return;
				}
			
			portfolio_form_modified_flag = 1;
			}
		}/* end selected line */
	}/* end for all lines */

show_items(SHOW_SAME_POSITION);

}/* end function portfolio_form_buy_button_cb */


void portfolio_form_sell_button_cb(FL_OBJECT *ob, long data)
{
int total_lines;
int s_line;
char *item;

total_lines = fl_get_browser_maxline(fdui -> portfolio_form_market_browser);
for(s_line = 1; s_line <= total_lines; s_line++)
	{
	if(fl_isselected_browser_line(\
	fdui -> portfolio_form_market_browser, s_line) )
		{
		portfolio_form_modified_flag = 1;
		item = (char *) line_to_item(s_line);
		if(item)
			{
			/*
			this updates account, taking into account share or option
			transaction costs, and warns if debet
			*/
			if(! sell_item(\
			item, portfolio_form_quantity, portfolio_form_item_price) )
				{
				fl_show_alert(\
				"Cannot add transaction to portfolio", "", "", 1);
				return;
				}

			/* 
			This updates quantity, price, also adds transaction to
			transaction list.
			*/
			if(!add_transaction_to_portfolio(\
			time(0), item,\
			portfolio_form_quantity, portfolio_form_item_price, SELL,\
			portfolio_form_cash) )
				{
				fl_show_alert("Cannot add transaction to portfolio", "", "", 1);
				return;
				}
			
			portfolio_form_modified_flag = 1;
			}
		}/* end selected line */
	}/* end for all lines */

show_items(SHOW_SAME_POSITION);

}/* end function portfolio_sell_button_cb */


void portfolio_form_delete_item_button_cb(FL_OBJECT *ob, long data)
{
int total_lines;
int s_line;
char *item;
char temp[512];

total_lines = fl_get_browser_maxline(fdui -> portfolio_form_market_browser);
for(s_line = 1; s_line <= total_lines; s_line++)
	{
	if(fl_isselected_browser_line(\
	fdui -> portfolio_form_market_browser, s_line) )
		{
		portfolio_form_modified_flag = 1;
		item = (char *) line_to_item(s_line);
		if(item)
			{
			/* warn user */
			/* 3 mouse in middle */
			sprintf(temp, "This will delete item\n%s\nare you sure?", item);
			if(! fl_show_question(temp, 3) )
				{
				continue;
				}
		
			/* finally delete structure entry */
			if(! delete_item(item) ) return;
			
			portfolio_form_modified_flag = 1;
			}/* end if item */
		}/* end selected line */
	}/* end for all lines */

show_items(SHOW_SAME_POSITION);
}/* end function portfolio_form_delete_item_button_cb */


void portfolio_form_delete_transaction_button_cb(FL_OBJECT *ob, long data)
{
int total_lines;
int s_line;
char *transaction;
char temp[512];

total_lines =\
	fl_get_browser_maxline(fdui -> portfolio_form_transaction_browser);
for(s_line = 1; s_line <= total_lines; s_line++)
	{
	if(fl_isselected_browser_line(\
	fdui -> portfolio_form_transaction_browser, s_line) )
		{
		portfolio_form_modified_flag = 1;
		transaction = (char *) line_to_transaction(s_line);
		if(transaction)
			{
			/* warn user */
			/* 3 mouse in middle */
			/* use text after first space ('@C13 ') in browser line */
			sprintf(temp,\
			"This will delete transaction\n%s\nare you sure?",\
			strchr( (char *)fl_get_browser_line(\
			fdui -> portfolio_form_transaction_browser, s_line), ' ') + 1);

			if(! fl_show_question(temp, 3) )
				{
				continue;
				}
		
			/* finally delete structure entry */
			if(! delete_transaction(transaction) ) return;
			
			portfolio_form_modified_flag = 1;
			}/* end if transaction */
		}/* end selected line */
	}/* end for all lines */

show_transactions(SHOW_SAME_POSITION);
}/* end function portfolio_form_delete_transaction_button_cb */


void portfolio_form_clear_button_cb(FL_OBJECT *ob, long data)
{
fl_set_input(fdui -> portfolio_form_quantity_input_field, "");
fl_set_input(fdui -> portfolio_form_fund_input_field, "");
fl_set_input(fdui -> portfolio_form_type_input_field, "");
fl_set_input(fdui -> portfolio_form_month_input_field, "");
fl_set_input(fdui -> portfolio_form_year_input_field, "");
fl_set_input(fdui -> portfolio_form_strikeprice_input_field, "");
fl_set_input(fdui -> portfolio_form_price_input_field, "");
}/* end function portfolio_form_clear_button_cb */


void portfolio_form_add_item_button_cb(FL_OBJECT *ob, long data)
{
int test_exists_flag;

test_exists_flag = 1;
if(! add_item_to_portfolio(\
portfolio_form_fund, portfolio_form_type,\
portfolio_form_month, portfolio_form_year, portfolio_form_strikeprice,\
test_exists_flag, portfolio_form_item_price) )
	{
	fl_show_alert("Cannot add item", "", "", 1);
	}

portfolio_form_modified_flag = 1;
}/* end function portfolio_form_add_item_button_cb */


void portfolio_form_add_transaction_button_cb(FL_OBJECT *ob, long data)
{
show_transaction_add_form();
}/* end function portfolio_form_add_transaction_button_cb */


void portfolio_form_quantity_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

portfolio_form_quantity = atof(ptr);

if(portfolio_form_quantity < 0)
	{
	fl_set_focus_object(fd_main_form -> portfolio_form, ob);
	fl_show_alert("Illegal quantity", ptr, "must >= 0", 1);
	}

}/* end function portfolio_form_quantity_input_field_cb */


void portfolio_form_fund_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

if(! portfolio_form_fund) free(portfolio_form_fund);
portfolio_form_fund = strsave(ptr);

}/* end function portfolio_form_fund_input_field_cb */


void portfolio_form_type_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *) fl_get_input(ob);
if(! ptr) return;

if(strcasecmp(ptr, "stock") == 0) portfolio_form_type = TYPE_STOCK;
else if(strcasecmp(ptr, "call") == 0) portfolio_form_type = TYPE_CALL;
else if(strcasecmp(ptr, "put") == 0) portfolio_form_type = TYPE_PUT;
else if(strcasecmp(ptr, "bond") == 0) portfolio_form_type = TYPE_BOND;
else
	{
	fl_set_focus_object(fd_main_form -> portfolio_form, ob);
	fl_show_alert("Illegal type" , ptr, "Legal are: stock call put", 1);
	portfolio_form_type = TYPE_UNKOWN;
	}
}/* end function portfolio_form_type_input_field_cb */


void portfolio_form_month_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

if(isdigit(ptr[0]) )
	{
	portfolio_form_month = atoi(ptr);	
	if(! portfolio_form_month)
		{
		fl_set_focus_object(fd_main_form -> portfolio_form, ob);
		fl_show_alert("Illegal month", ptr, "Use: 1 - 12 or jan feb ..", 1);
		return;
		}
	}
else
	{
	portfolio_form_month = month_to_digit(ptr);
	if( (portfolio_form_month < 1) || (portfolio_form_month > 12) )
		{	
		fl_show_alert("Illegal month", ptr, "Use: 1 - 12 or jan feb ..", 1);
		return;
		}
	return;
	}
}/* end function portfolio_form_month_input_field_cb */


void portfolio_form_year_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

portfolio_form_year = atoi(ptr);
if(portfolio_form_year < 1900)
	{
	fl_set_focus_object(fd_main_form -> portfolio_form, ob);
	fl_show_alert("Illegal year", ptr, "usage: 1999 etc.", 1);
	}

}/* end function portfolio_form_year_input_field_cb */


void portfolio_form_strikeprice_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

portfolio_form_strikeprice = atof(ptr);
if(portfolio_form_strikeprice < 0)
	{
	fl_set_focus_object(fd_main_form -> portfolio_form, ob);
	fl_show_alert("Illegal strike price", ptr, "must be > 0", 1);
	}

}/* end function portfolio_form_strikeprice_input_field_cb */


void portfolio_form_market_group_fontsize_up_button_cb(\
	FL_OBJECT *ob, long data)
{
int size;

fontsizes_modified_flag = 1;

if(portfolio_form_market_group_fontsize < 5)\
	portfolio_form_market_group_fontsize++;
size = integer_to_fontsize(portfolio_form_market_group_fontsize);
fl_set_browser_fontsize(fdui -> portfolio_form_market_browser, size);

/*fl_set_object_lsize(fdui -> portfolio_form_input_field, size);*/
}/* end function portfolio_form_market_group_fontsize_up_button_cb */


void portfolio_form_market_group_fontsize_down_button_cb(\
	FL_OBJECT *ob, long data)
{
int size;

fontsizes_modified_flag = 1;
if(portfolio_form_market_group_fontsize > 0)\
	portfolio_form_market_group_fontsize--;
size = integer_to_fontsize(portfolio_form_market_group_fontsize);

fl_set_browser_fontsize(fdui -> portfolio_form_market_browser, size);

/*fl_set_object_lsize(fdui -> portfolio_form_input_field, size);*/
}/* end function portfolio_form_market_group_fontsize_down_button_cb */


void portfolio_form_transaction_group_fontsize_up_button_cb(\
	FL_OBJECT *ob, long data)
{
int size;

fontsizes_modified_flag = 1;

if(portfolio_form_transaction_group_fontsize < 5)\
	portfolio_form_transaction_group_fontsize++;
size = integer_to_fontsize(portfolio_form_transaction_group_fontsize);
fl_set_browser_fontsize(fdui -> portfolio_form_transaction_browser, size);

/*fl_set_object_lsize(fdui -> portfolio_form_input_field, size);*/
}/* end function portfolio_form_transaction_group_fontsize_up_button_cb */


void portfolio_form_transaction_group_fontsize_down_button_cb(\
	FL_OBJECT *ob, long data)
{
int size;

fontsizes_modified_flag = 1;
if(portfolio_form_transaction_group_fontsize > 0)\
	portfolio_form_transaction_group_fontsize--;
size = integer_to_fontsize(portfolio_form_transaction_group_fontsize);

fl_set_browser_fontsize(fdui -> portfolio_form_transaction_browser, size);

/*fl_set_object_lsize(fdui -> portfolio_form_input_field, size);*/
}/* end function portfolio_form_transaction_group_fontsize_down_button_cb */


void portfolio_form_accept_button_cb(FL_OBJECT *ob, long data)
{
if(fontsizes_modified_flag)
	{
	save_fontsizes();
	fontsizes_modified_flag = 0;
	}

save_items();
save_transactions();

fl_hide_form(fdui -> portfolio_form);

portfolio_form_shown_flag = 0;

}/* end function portfolio_form_accept_button_cb */


void portfolio_form_cancel_button_cb(FL_OBJECT *ob, long data)
{

if(portfolio_form_modified_flag)
	{
	/* ask user for confirmation */
	if(! fl_show_question("Loose any changes you made?", 3) ) return;
	}

if(fontsizes_modified_flag)
	{
	load_fontsizes();
	fontsizes_modified_flag = 0;
	}

fl_hide_form(fdui -> portfolio_form);

/* restore data in the market browser */
load_items();

/* restore data in transaction_browser */
load_transactions();

portfolio_form_shown_flag = 0;

}/* end function portfolio_form_cancel_button_cb */


void portfolio_form_import_menu_cb(FL_OBJECT *ob, long data)
{
int portfolio_form_import_menu_selection;

portfolio_form_import_menu_selection = fl_get_menu(ob);

/* if nothing selected, but mouse in menu, no action */
if(portfolio_form_import_menu_selection <= 0) return;

if(portfolio_form_import_menu_selection == IMPORT_DAVIEFF_OPTIONS)
	{
	if(! fl_show_question(\
	"This will import new options\nexisting data may be modified!\n\
	are you sure?",\
	3) )
		{
		return;
		}

	if(! import_davieff_file(OPTIONS_FILE) )
		{
		fl_show_alert("Cannot import davieff options file", "" , "", 1);
		return;
		}

	portfolio_form_modified_flag = 1;
	}/* end if IMPORT_DAVIEFF_OPTIONS */
else if(portfolio_form_import_menu_selection == IMPORT_DAVIEFF_SHARES)
	{
	if(! fl_show_question(\
	"This will import new shares\nexisting data may be modified!\n\
	are you sure?",\
	3) )
		{
		return;
		}

	if(! import_davieff_file(SHARES_FILE) )
		{
		fl_show_alert("Cannot import davieff shares file", "" , "", 1);
		return;
		}

	portfolio_form_modified_flag = 1;
	}/* end if IMPORT_DAVIEFF_SHARES */
else if(portfolio_form_import_menu_selection == IMPORT_FASTSERVICE_EMAIL)
	{
	if(! fl_show_question(\
	"This will import new shares\nexisting data may be modified!\n\
	are you sure?",\
	3) )
		{
		return;
		}

	if(! import_fastservice_files() )
		{
		fl_show_alert(\
		"Cannot import fastservice shares files", "from incoming email" , "",\
		1);
		return;
		}

	portfolio_form_modified_flag = 1;
	}/* end if IMPORT_FASTSERVICE_EMAIL */

}/* end function portfolio_form_import_menu_cb */


void portfolio_form_chart_menu_cb(FL_OBJECT *ob, long data)
{
int portfolio_form_chart_menu_selection;

portfolio_form_chart_menu_selection = fl_get_menu(ob);

/* if nothing selected, but mouse in menu, no action */
if(portfolio_form_chart_menu_selection <= 0) return;

if(portfolio_form_chart_menu_selection == WHERE_YOUR_MONEY_IS)
	{
	if(! show_where_the_money_is_chart() ) return;

	return;
	}
else if(portfolio_form_chart_menu_selection == HIDE_CHARTS)
	{
	
	fl_hide_object(fdui -> portfolio_form_special_pie_chart);

	show_where_the_money_is_chart_shown_flag = 0;
	return;
	}

return;
}/* end function portfolio_form_chart_menu_cb */


void portfolio_form_update_menu_cb(FL_OBJECT *ob, long data)
{
int portfolio_form_update_menu_selection;

portfolio_form_update_menu_selection = fl_get_menu(ob);

/* if nothing selected, but mouse in menu, no action */
if(portfolio_form_update_menu_selection <= 0) return;

if(portfolio_form_update_menu_selection == UPDATE_KRS_FILES_FROM_PORTFOLIO)
	{
	if(! update_krs_files_from_portfolio() ) 
		{
		return;
		}
	return;
	}
else if(portfolio_form_update_menu_selection == UPDATE_KRS_FILES_FROM_FASTSERVICE_EMAIL)
	{
	if(! update_krs_files_from_fastservice_email() )
		{
		return;
		}
	return;
	}

return;
}/* end function portfolio_form_update_menu_cb */


