/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "xkra.h"

FD_xkra *fdui;


int read_settings()
{
int a;
char temp[1024];
float fa, fb, fc;
char field1[512];
FILE *fptr;
char *ptr;

if(debug_flag)
	{
	fprintf(stdout, "read_settings(): arg none\n");
	}

fptr = fopen(moving_averages_path_filename, "r");
if(! fptr)
	{
/*
	fl_show_alert(\
	"Cannot open file for read",\
	moving_averages_path_filename,\
	"(Using optimize creates it)",\
	1);
*/
	/* 1 = centered */
	return(0);
	}

/* moving averages */
a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
a = atoi(ptr);
sprintf(field1, "%d", a);
fl_set_input(fdui -> ma1_input, field1);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fa = atof(ptr);
sprintf(field1, "%.1f", fa);
fl_set_input(fdui -> mawei1_input, field1);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
a = atoi(ptr);
sprintf(field1, "%d", a);
fl_set_input(fdui -> ma1_lead_input, field1);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
a = atoi(ptr);
sprintf(field1, "%d", a);
fl_set_input(fdui -> ma2_input, field1);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fa = atof(ptr);
sprintf(field1, "%.1f", fa);
fl_set_input(fdui -> mawei2_input, field1);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
a = atoi(ptr);
sprintf(field1, "%d", a);
fl_set_input(fdui -> ma2_lead_input, field1);

/* momentum */
a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
a = atoi(ptr);
sprintf(field1, "%d", a);
fl_set_input(fdui -> momentum_days_input, field1);

/* relative file */
a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fl_set_input(fdui -> relative_file_input, ptr);

/* file read OK */
fclose(fptr);

return(1);
}/* end function read_settings */


int write_settings()
{
char *ptr;
FILE *fptr;
char temp[1024];

if(debug_flag)
	{
	fprintf(stdout, "write_settings(): arg none\n");
	}

fptr = fopen(moving_averages_path_filename, "w");
if(! fptr)
	{
	fl_show_alert(\
	"Cannot open file", moving_averages_path_filename, "for write", 1);/* 1 = centered */
	return(0);
	}

/* moving averages */
ptr = (char *)fl_get_input(fdui -> ma1_input);
fprintf(fptr, "madays1=%s\n", ptr);

ptr = (char *)fl_get_input(fdui -> mawei1_input);
fprintf(fptr, "maweight1=%s\n", ptr);

ptr = (char *)fl_get_input(fdui -> ma1_lead_input);
fprintf(fptr, "malead1=%s\n", ptr);

ptr = (char *)fl_get_input(fdui -> ma2_input);
fprintf(fptr, "madays2=%s\n", ptr);

ptr = (char *)fl_get_input(fdui -> mawei2_input);
fprintf(fptr, "maweight2=%s\n", ptr);

ptr = (char *)fl_get_input(fdui -> ma2_lead_input);
fprintf(fptr, "malead2=%s\n", ptr);

/* momentum */
ptr = (char *)fl_get_input(fdui -> momentum_days_input);
fprintf(fptr, "mom_days=%s\n", ptr);

/* relative file */
ptr = (char *)fl_get_input(fdui -> relative_file_input);
fprintf(fptr, "relative_file=%s\n", ptr);

fclose(fptr);
return(1);
}/* end function write_settings */


int save_setting(char *type, char *string)
{
char pathfilename[READSIZE];
FILE *setting_file;

/* combine with home directory */
sprintf(pathfilename, "%s/.xkra/setup/%s", home_dir, type);
setting_file = fopen(pathfilename, "w");
if(! setting_file)
	{
	fl_show_alert("Cannot open file for write:", pathfilename, "", 0);
	if(debug_flag)
		{
		fprintf(stdout, "\nCannot open setting file %s for write\n",\
		pathfilename);
		}
	return(0);
	}

fprintf(setting_file, "%s", string);
fclose(setting_file);
return(1);	
}/* end function save_setting */


char *load_setting(char *type)
{
int a;
char temp[1024];
char pathfilename[READSIZE];
FILE *setting_file;

/* combine with home directory */
sprintf(pathfilename, "%s/.xkra/setup/%s", home_dir, type);
setting_file = fopen(pathfilename, "r");
if(! setting_file)
	{
	fl_show_alert(\
	"Cannot open file for read:", pathfilename, "using defaults", 0);
	if(debug_flag)
		{
		fprintf(stdout, "\nCannot open setting file %s for read\n",\
		pathfilename);
		}
	return(0);
	}

a = readline(setting_file, temp);/* closes file if EOF */	
if(a != EOF) fclose(setting_file);
return(strsave(temp) );
}/* end function load_setting */


int save_fontsizes()
{
char temp[READSIZE];
sprintf(temp,\
"%d %d %d %d %d",\
portfolio_form_market_group_fontsize,\
portfolio_form_transaction_group_fontsize,\
share_rates_form_fontsize,\
option_rates_form_fontsize,\
option_evaluation_form_fontsize\
);
if(! save_setting("fontsizes", temp) ) return(0);

return(1);
}/* end function save_fontsizes */


int load_fontsizes()
{
char *data_read;
 
data_read = (char *) load_setting("fontsizes");
if(! data_read) return(0);

sscanf(data_read,\
"%d %d %d %d %d",\
&portfolio_form_market_group_fontsize,\
&portfolio_form_transaction_group_fontsize,\
&share_rates_form_fontsize,\
&option_rates_form_fontsize,\
&option_evaluation_form_fontsize\
);

free(data_read);

fl_set_browser_fontsize(fdui -> portfolio_form_market_browser,\
integer_to_fontsize(portfolio_form_market_group_fontsize) );

fl_set_browser_fontsize(fdui -> portfolio_form_transaction_browser,\
integer_to_fontsize(portfolio_form_transaction_group_fontsize) );

fl_set_browser_fontsize(fdui -> option_evaluation_form_option_browser,\
integer_to_fontsize(option_evaluation_form_fontsize) );

return(1);
}/* end function load_fontsizes */


int save_stock_directory_setting()
{
char temp[READSIZE];

sprintf(temp, "%s", file_path);
if(! save_setting("stock_directory", temp) ) return(0);

return(1);
}/* end function save_stock_directory_setting */


int load_stock_directory_setting()
{
char *data_read;
 
data_read = (char *) load_setting("stock_directory");
if(! data_read)
	{
	fl_set_input(fdui -> directory_input, file_path);
	return(0);
	}

sscanf(data_read,\
"%s",\
file_path);

fl_set_input(fdui -> directory_input, file_path);

free(data_read);

return(1);
}/* end function load_fontsizes */


int save_global_settings()
{
int error_flag;

error_flag = 0;
if(! save_stock_directory_setting() ) error_flag = 1;
if(! save_new_york_offset() ) error_flag = 1;

if(error_flag) return 0;

return 1;
}/* end function save_global_settings */


int load_global_settings()
{
int error_flag;

error_flag = 0;
if(! load_stock_directory_setting() ) error_flag = 1;

if(! load_fontsizes() ) error_flag = 1;

if(! load_new_york_offset() ) error_flag = 1;

if(error_flag) return 0;

return 1;
}/* end function load_global_settings */


int load_new_york_offset()
{
char *data_read;
char temp[40];

data_read = (char *) load_setting("new_york_offset");
if(! data_read)
	{
	new_york_offset = NEW_YORK_OFFSET;

	return 0;
	}

sscanf(data_read, "%39s", temp);
free(data_read);

new_york_offset = atoi(temp);

return(1);
}/* end function load_new_york_offset */


int save_new_york_offset()
{
char temp[40];

sprintf(temp, "%d", new_york_offset);
if(! save_setting("new_york_offset", temp) ) return 0;

return 1;
}/* end function save_new_york_offset */


