/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "xkra.h"

FD_xkra *fdui;


#define FIELD_EMPTY			1
#define FIELD_PERCENTAGE	2
#define FIELD_VALUE			3
#define FIELD_QUANTITY		4

float share_rates_form_buy_minimum;
float share_rates_form_buy_from1;
float share_rates_form_buy_to1;
float share_rates_form_buy_value1;
float share_rates_form_buy_from2;
float share_rates_form_buy_to2;
float share_rates_form_buy_value2;
float share_rates_form_buy_from3;
float share_rates_form_buy_to3;
float share_rates_form_buy_value3;
float share_rates_form_buy_from4;
float share_rates_form_buy_to4;
float share_rates_form_buy_value4;
float share_rates_form_buy_fixed;

float share_rates_form_sell_minimum;
float share_rates_form_sell_from1;
float share_rates_form_sell_to1;
float share_rates_form_sell_value1;
float share_rates_form_sell_from2;
float share_rates_form_sell_to2;
float share_rates_form_sell_value2;
float share_rates_form_sell_from3;
float share_rates_form_sell_to3;
float share_rates_form_sell_value3;
float share_rates_form_sell_from4;
float share_rates_form_sell_to4;
float share_rates_form_sell_value4;
float share_rates_form_sell_fixed;

int share_rates_form_buy_minimum_field_type;
int share_rates_form_buy_from1_field_type;
int share_rates_form_buy_value1_field_type;
int share_rates_form_buy_from2_field_type;
int share_rates_form_buy_value2_field_type;
int share_rates_form_buy_from3_field_type;
int share_rates_form_buy_value3_field_type;
int share_rates_form_buy_from4_field_type;
int share_rates_form_buy_value4_field_type;
int share_rates_form_buy_fixed_field_type;

int share_rates_form_sell_minimum_field_type;
int share_rates_form_sell_from1_field_type;
int share_rates_form_sell_value1_field_type;
int share_rates_form_sell_from2_field_type;
int share_rates_form_sell_value2_field_type;
int share_rates_form_sell_from3_field_type;
int share_rates_form_sell_value3_field_type;
int share_rates_form_sell_from4_field_type;
int share_rates_form_sell_value4_field_type;
int share_rates_form_sell_fixed_field_type;

static char currency_symbol[40];
static int share_rates_form_include_flag;

static int buy_from_type;
static int buy_value_type;

static int sell_from_type;
static int sell_value_type;


int read_share_rates()
{
int a;
char temp[4096];
float fa;
FILE *fptr;
char *ptr;

if(debug_flag)
	{
	fprintf(stdout, "read_share_rates(): arg none\n");
	}

if(share_rates_form_rates_read_flag) return(1);

sprintf(temp, "%s/share_rates.dat", file_path);
fptr = fopen(temp, "r");
if(! fptr)
	{
	fl_show_alert(\
	"Cannot open file", temp, "for read", 1);/* 1 = centered */
	/*
	show empty form, user should enter something, then create file by
	using accept button.
	*/
	fl_show_form(fdui -> share_rates_form, FL_PLACE_CENTER, FL_NOBORDER, "");
	return(0);
	}

/* buy rates */
a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fa = atof(ptr);
fl_set_input(fdui -> share_rates_form_buy_minimum_input_field, ptr);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fa = atof(ptr);
fl_set_input(fdui -> share_rates_form_buy_from1_input_field, ptr);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fa = atof(ptr);
fl_set_input(fdui -> share_rates_form_buy_value1_input_field, ptr);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fa = atof(ptr);
fl_set_input(fdui -> share_rates_form_buy_from2_input_field, ptr);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fa = atof(ptr);
fl_set_input(fdui -> share_rates_form_buy_value2_input_field, ptr);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fa = atof(ptr);
fl_set_input(fdui -> share_rates_form_buy_from3_input_field, ptr);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fa = atof(ptr);
fl_set_input(fdui -> share_rates_form_buy_value3_input_field, ptr);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fa = atof(ptr);
fl_set_input(fdui -> share_rates_form_buy_from4_input_field, ptr);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fa = atof(ptr);
fl_set_input(fdui -> share_rates_form_buy_value4_input_field, ptr);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fa = atof(ptr);
fl_set_input(fdui -> share_rates_form_buy_fixed_input_field, ptr);

/* sell rates */
a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fa = atof(ptr);
fl_set_input(fdui -> share_rates_form_sell_minimum_input_field, ptr);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fa = atof(ptr);
fl_set_input(fdui -> share_rates_form_sell_from1_input_field, ptr);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fa = atof(ptr);
fl_set_input(fdui -> share_rates_form_sell_value1_input_field, ptr);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fa = atof(ptr);
fl_set_input(fdui -> share_rates_form_sell_from2_input_field, ptr);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fa = atof(ptr);
fl_set_input(fdui -> share_rates_form_sell_value2_input_field,  ptr);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fa = atof(ptr);
fl_set_input(fdui -> share_rates_form_sell_from3_input_field, ptr);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fa = atof(ptr);
fl_set_input(fdui -> share_rates_form_sell_value3_input_field, ptr);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fa = atof(ptr);
fl_set_input(fdui -> share_rates_form_sell_from4_input_field, ptr);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fa = atof(ptr);
fl_set_input(fdui -> share_rates_form_sell_value4_input_field, ptr);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fa = atof(ptr);
fl_set_input(fdui -> share_rates_form_sell_fixed_input_field, ptr);

a = readline(fptr, temp);
if(a == EOF) return(0);
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
fl_set_input(fdui -> share_rates_form_currency_symbol_input_field, ptr);
	
a = readline(fptr, temp);
if(a == EOF) return 0;
ptr = strchr(temp, '=');
if(! ptr)
	{
	fclose(fptr);
	return(0);
	}
ptr++;
a  = atoi(ptr);
fl_set_button(fdui -> share_rates_form_include_button, a);

fclose(fptr);

if(! set_share_rates_form_variables() ) return(0);

share_rates_form_rates_read_flag = 1;
return(1);
}/* end function read_share_rates */


int write_share_rates()
{
int a;
char *ptr;
FILE *fptr;
char temp[1024];

if(debug_flag)
	{
	fprintf(stdout, "write_share_rates(); arg none\n");
	}

sprintf(temp, "%s/share_rates.dat", file_path);
fptr = fopen(temp, "w");
if(! fptr)
	{
	fl_show_alert(\
	"Cannot open file", temp, "for write", 1);/* 1 = centered */
	return(0);
	}

/* buy rates */
ptr = (char *)fl_get_input(fdui -> share_rates_form_buy_minimum_input_field);
fprintf(fptr, "minimum=%s\n", ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_buy_from1_input_field);
fprintf(fptr, "from1=%s\n", ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_buy_value1_input_field);
fprintf(fptr, "value1=%s\n", ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_buy_from2_input_field);
fprintf(fptr, "from2=%s\n", ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_buy_value2_input_field);
fprintf(fptr, "value2=%s\n", ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_buy_from3_input_field);
fprintf(fptr, "from3=%s\n", ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_buy_value3_input_field);
fprintf(fptr, "value3=%s\n", ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_buy_from4_input_field);
fprintf(fptr, "from4=%s\n", ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_buy_value4_input_field);
fprintf(fptr, "value4=%s\n", ptr);

/* 
NOTE: using 'maximum=' in read, writing 'fixed=' for compatibility with
old format from -0.5
*/
ptr = (char *)fl_get_input(fdui -> share_rates_form_buy_fixed_input_field);
fprintf(fptr, "fixed=%s\n", ptr);

/* sell rates */
ptr = (char *)fl_get_input(fdui -> share_rates_form_sell_minimum_input_field);
fprintf(fptr, "minimum=%s\n", ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_sell_from1_input_field);
fprintf(fptr, "from1=%s\n", ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_sell_value1_input_field);
fprintf(fptr, "value1=%s\n", ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_sell_from2_input_field);
fprintf(fptr, "from2=%s\n", ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_sell_value2_input_field);
fprintf(fptr, "value2=%s\n", ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_sell_from3_input_field);
fprintf(fptr, "from3=%s\n", ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_sell_value3_input_field);
fprintf(fptr, "value3=%s\n", ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_sell_from4_input_field);
fprintf(fptr, "from4=%s\n", ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_sell_value4_input_field);
fprintf(fptr, "value4=%s\n", ptr);

/* 
NOTE: using 'maximum=' in read, writing 'fixed=' for compatibility with
old format from -0.5
*/
ptr = (char *)fl_get_input(fdui -> share_rates_form_sell_fixed_input_field);
fprintf(fptr, "fixed=%s\n", ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_currency_symbol_input_field);
fprintf(fptr, "currency_symbol=%s\n", ptr);

a = fl_get_button(fdui -> share_rates_form_include_button);
fprintf(fptr, "include=%d\n", a);

fclose(fptr);
return(1);
}/* end function write_share_rates */


int set_share_rates_form_variables()
{
int a;
char *ptr;

if(debug_flag)
	{
	fprintf(stdout, "set_share_rates_form_variables() arg none\n");
	}

/* need this first, get_share_rates_form_field_type() uses it */
sprintf(currency_symbol, "%s",\
(char *)fl_get_input(fdui -> share_rates_form_currency_symbol_input_field) );

/* rates include */
share_rates_form_include_flag = fl_get_button(fdui -> share_rates_form_include_button);

/* buy */
ptr = (char *)fl_get_input(fdui -> share_rates_form_buy_minimum_input_field);
share_rates_form_buy_minimum = atof(ptr);
share_rates_form_buy_minimum_field_type = get_share_rates_form_field_type(ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_buy_from1_input_field);
share_rates_form_buy_from1 = atof(ptr);
share_rates_form_buy_from1_field_type = get_share_rates_form_field_type(ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_buy_value1_input_field);
share_rates_form_buy_value1 = atof(ptr);
share_rates_form_buy_value1_field_type = get_share_rates_form_field_type(ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_buy_from2_input_field);
share_rates_form_buy_from2 = atof(ptr);
share_rates_form_buy_from2_field_type = get_share_rates_form_field_type(ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_buy_value2_input_field);
share_rates_form_buy_value2 = atof(ptr);
share_rates_form_buy_value2_field_type = get_share_rates_form_field_type(ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_buy_from3_input_field);
share_rates_form_buy_from3 = atof(ptr);
share_rates_form_buy_from3_field_type = get_share_rates_form_field_type(ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_buy_value3_input_field);
share_rates_form_buy_value3 = atof(ptr);
share_rates_form_buy_value3_field_type = get_share_rates_form_field_type(ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_buy_from4_input_field);
share_rates_form_buy_from4 = atof(ptr);
share_rates_form_buy_from4_field_type = get_share_rates_form_field_type(ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_buy_value4_input_field);
share_rates_form_buy_value4 = atof(ptr);
share_rates_form_buy_value4_field_type = get_share_rates_form_field_type(ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_buy_fixed_input_field);
share_rates_form_buy_fixed = atof(ptr);
share_rates_form_buy_fixed_field_type = get_share_rates_form_field_type(ptr);

/* sell */
ptr = (char *)fl_get_input(fdui -> share_rates_form_sell_minimum_input_field);
share_rates_form_sell_minimum = atof(ptr);
share_rates_form_sell_minimum_field_type = get_share_rates_form_field_type(ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_sell_from1_input_field);
share_rates_form_sell_from1 = atof(ptr);
share_rates_form_sell_from1_field_type = get_share_rates_form_field_type(ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_sell_value1_input_field);
share_rates_form_sell_value1 = atof(ptr);
share_rates_form_sell_value1_field_type = get_share_rates_form_field_type(ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_sell_from2_input_field);
share_rates_form_sell_from2 = atof(ptr);
share_rates_form_sell_from2_field_type = get_share_rates_form_field_type(ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_sell_value2_input_field);
share_rates_form_sell_value2 = atof(ptr);
share_rates_form_sell_value2_field_type = get_share_rates_form_field_type(ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_sell_from3_input_field);
share_rates_form_sell_from3 = atof(ptr);
share_rates_form_sell_from3_field_type = get_share_rates_form_field_type(ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_sell_value3_input_field);
share_rates_form_sell_value3 = atof(ptr);
share_rates_form_sell_value3_field_type = get_share_rates_form_field_type(ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_sell_from4_input_field);
share_rates_form_sell_from4 = atof(ptr);
share_rates_form_sell_from4_field_type = get_share_rates_form_field_type(ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_sell_value4_input_field);
share_rates_form_sell_value4 = atof(ptr);
share_rates_form_sell_value4_field_type = get_share_rates_form_field_type(ptr);

ptr = (char *)fl_get_input(fdui -> share_rates_form_sell_fixed_input_field);
share_rates_form_sell_fixed = atof(ptr);
share_rates_form_sell_fixed_field_type = get_share_rates_form_field_type(ptr);

a = 0;
buy_from_type = share_rates_form_buy_from1_field_type;
if(share_rates_form_buy_from2_field_type != FIELD_EMPTY) 
	{
	if(share_rates_form_buy_from2_field_type != share_rates_form_buy_from1_field_type) a = 1;
	}
if(share_rates_form_buy_from3_field_type != FIELD_EMPTY) 
	{
	if(share_rates_form_buy_from3_field_type != share_rates_form_buy_from1_field_type) a = 1;
	}
if(share_rates_form_buy_from4_field_type != FIELD_EMPTY) 
	{
	if(share_rates_form_buy_from4_field_type != share_rates_form_buy_from1_field_type) a = 1;
	}
if(a)
	{
	fl_show_alert(\
	"Inconsistent entries in 'BUY from'", "in rates form", "", 1);
	
	return(0);
	}

a = 0;
buy_value_type = share_rates_form_buy_value1_field_type;
if(share_rates_form_buy_value2_field_type != FIELD_EMPTY) 
	{
	if(share_rates_form_buy_value2_field_type != share_rates_form_buy_value1_field_type) a = 1;
	}
if(share_rates_form_buy_value3_field_type != FIELD_EMPTY) 
	{
	if(share_rates_form_buy_value3_field_type != share_rates_form_buy_value1_field_type) a = 1;
	}
if(share_rates_form_buy_value4_field_type != FIELD_EMPTY) 
	{
	if(share_rates_form_buy_value4_field_type != share_rates_form_buy_value1_field_type) a = 1;
	}
if(a)
	{
	fl_show_alert(\
	"Inconsistent entries in 'BUY value'", "in rates form", "", 1);
	
	return(0);
	}

a = 0;
sell_from_type = share_rates_form_sell_from1_field_type;
if(share_rates_form_sell_from2_field_type != FIELD_EMPTY) 
	{
	if(share_rates_form_sell_from2_field_type != share_rates_form_sell_from1_field_type) a = 1;
	}
if(share_rates_form_sell_from3_field_type != FIELD_EMPTY) 
	{
	if(share_rates_form_sell_from3_field_type != share_rates_form_sell_from1_field_type) a = 1;
	}
if(share_rates_form_sell_from4_field_type != FIELD_EMPTY) 
	{
	if(share_rates_form_sell_from4_field_type != share_rates_form_sell_from1_field_type) a = 1;
	}
if(a)
	{
	fl_show_alert(\
	"Inconsistent entries in 'SELL from'", "in rates form", "", 1);
	
	return(0);
	}

a = 0;
sell_value_type = share_rates_form_sell_value1_field_type;
if(share_rates_form_sell_value2_field_type != FIELD_EMPTY) 
	{
	if(share_rates_form_sell_value2_field_type != share_rates_form_sell_value1_field_type) a = 1;
	}
if(share_rates_form_sell_value3_field_type != FIELD_EMPTY) 
	{
	if(share_rates_form_sell_value3_field_type != share_rates_form_sell_value1_field_type) a = 1;
	}
if(share_rates_form_sell_value4_field_type != FIELD_EMPTY) 
	{
	if(share_rates_form_sell_value4_field_type != share_rates_form_sell_value1_field_type) a = 1;
	}
if(a)
	{
	fl_show_alert(\
	"Inconsistent entries in 'SELL value'", "in rates form", "", 1);
	
	return(0);
	}

return(1);
}/* end function set_share_rates_form_variables */


int get_share_rates_form_field_type(char *field)
{
if(debug_flag)
	{
	fprintf(stdout, "get_share_rates_form_field_type(): arg field=%s\n",\
	field);
	}

if(! field) return(0);

if(strlen(field) == 0) return(FIELD_EMPTY);
if(strchr(field, '%') ) return(FIELD_PERCENTAGE);
if(strstr(field, currency_symbol) )
	{
	return(FIELD_VALUE);
	}
return(FIELD_QUANTITY);
}/* end function get_share_rates_form_field_type */


int get_share_transaction_cost(\
int mode, float transaction_quantity, float share_price,\
float transaction_price, float *transaction_cost)
{
float buy_limit;
float schijf1, schijf2, schijf3;
float inschijf1, inschijf2, inschijf3;
float quantity;
float cost;
int from_type, value_type;
float divider;

if(debug_flag)
	{
	fprintf(stdout,\
	"get_share_transaction_cost(): arg\n\
	mode=%d transaction_quantity=%.2f share_price=%.2f transaction_price=%.2f\n",\
	mode, transaction_quantity, share_price, transaction_price);
	}

if(share_rates_form_shown_flag)
	{
	fl_show_alert(\
	"Close share rates form first (use accapt)", "command cancelled", "", 1);
	return 0;
	}

if(! read_share_rates() )
	{
	if(debug_flag)
		{
		fprintf(stdout,\
		"get_share_transaction_cost(): cannot read_share_rates\n");
		}

	fl_show_alert("Cannot read share rates", "command cancelled", "", 1);
	return 0;
	}

if(debug_flag)
	{
	fprintf(stdout,\
	"get_share_transaction_cost(): using globals:\n\
	currency_symbol=%s\n\
	share_rates_form_buy_minimum_field_type=%d\n\
	share_rates_form_buy_minimum=%.2f\n\
	share_rates_form_buy_from1_field_type=%d\n\
	share_rates_form_buy_from1=%.2f\n\
	share_rates_form_buy_value1_field_type=%d\n\
	share_rates_form_buy_value1=%.2f\n\
	share_rates_form_buy_from2_field_type=%d\n\
	share_rates_form_buy_from2=%.2f\n\
	share_rates_form_buy_value2_field_type=%d\n\
	share_rates_form_buy_value2=%.2f\n\
	share_rates_form_buy_from3_field_type=%d\n\
	share_rates_form_buy_from3=%.2f\n\
	share_rates_form_buy_value3_field_type=%d\n\
	share_rates_form_buy_value3=%.2f\n\
	share_rates_form_buy_from4_field_type=%d\n\
	share_rates_form_buy_from4=%.2f\n\
	share_rates_form_buy_value4_field_type=%d\n\
	share_rates_form_buy_value4=%.2f\n\
	share_rates_form_buy_fixed_field_type=%d\n\
	share_rates_form_buy_fixed=%.2f\n\
	buy_from_type=%d\n\
	buy_value_type=%d\n\
	sell_from_type=%d\n\
	sell_value_type=%d\n",\
	currency_symbol,\
	share_rates_form_buy_minimum_field_type,\
	share_rates_form_buy_minimum,\
	share_rates_form_buy_from1_field_type,\
	share_rates_form_buy_from1,\
	share_rates_form_buy_value1_field_type,\
	share_rates_form_buy_value1,\
	share_rates_form_buy_from2_field_type,\
	share_rates_form_buy_from2,\
	share_rates_form_buy_value2_field_type,\
	share_rates_form_buy_value2,\
	share_rates_form_buy_from3_field_type,\
	share_rates_form_buy_from3,\
	share_rates_form_buy_value3_field_type,\
	share_rates_form_buy_value3,\
	share_rates_form_buy_from4_field_type,\
	share_rates_form_buy_from4,\
	share_rates_form_buy_value4_field_type,\
	share_rates_form_buy_value4,\
	share_rates_form_buy_fixed_field_type,\
	share_rates_form_buy_fixed,\
	buy_from_type,\
	buy_value_type,\
	sell_from_type,\
	sell_value_type);
	}/* end if debug_flag */

*transaction_cost = 0;
cost = 0;
if(mode == BUY)
	{
	if(buy_from_type == FIELD_VALUE) quantity = transaction_price;
	else if(buy_from_type == FIELD_QUANTITY) quantity = transaction_quantity;
	else
		{
		fl_show_alert(\
		"Illegal entry in 'BUY from'", "in rates form", "", 1);	
		return(0);
		}

	if( (buy_value_type != FIELD_PERCENTAGE) &&\
	(buy_value_type != FIELD_VALUE) )
		{
		fl_show_alert(\
		"Illegal entry in 'BUY value'", "in rates form", "", 1);
		return(0);
		}

	schijf1 = share_rates_form_buy_from2 - share_rates_form_buy_from1;
	schijf2 = share_rates_form_buy_from3 - share_rates_form_buy_from2;
	schijf3 = share_rates_form_buy_from4 - share_rates_form_buy_from3;

	inschijf1 = inschijf2 = inschijf3 = 0;

	if(quantity < schijf1) {inschijf1 = quantity; quantity = 0;}
	else {inschijf1 = schijf1; quantity -= schijf1;}
	if(quantity > 0)
		{
		if(quantity < schijf2) {inschijf2 = quantity; quantity = 0;}
		else {inschijf2 = schijf2; quantity -= schijf2;}
		if(quantity > 0)
			{	
			if(quantity < schijf3) {inschijf3 = quantity; quantity = 0;}
			else {inschijf3 = schijf3; quantity -= schijf3;}
			}		
		}
	if(quantity < 0) quantity = 0;

	if( (buy_from_type == FIELD_QUANTITY) && (buy_value_type == FIELD_VALUE) )
		{
		/* quantity in schijf, money in value */
		cost += inschijf1 * share_rates_form_buy_value1;
		cost += inschijf2 * share_rates_form_buy_value2;
		cost += inschijf3 * share_rates_form_buy_value3;
		cost += quantity * share_rates_form_buy_value4;
		}
	if( (buy_from_type == FIELD_QUANTITY) && (buy_value_type == FIELD_PERCENTAGE) )
		{
		/* quantity in schijf, percentage transaction in value */
		cost += inschijf1 * share_price * (share_rates_form_buy_value1 / 100.0);
		cost += inschijf2 * share_price * (share_rates_form_buy_value2 / 100.0);
		cost += inschijf3 * share_price * (share_rates_form_buy_value3 / 100.0);
		cost += quantity * share_price * (share_rates_form_buy_value4 / 100.0);
		}
	if( (buy_from_type == FIELD_VALUE) && (buy_value_type == FIELD_VALUE) )
		{
		/* money in in schijf, money in value, results in problem? */
		/* say: 4 $ for the first 1000$, 3$ for above 1000$ */
		cost += inschijf1 * share_rates_form_buy_value1;
		cost += inschijf2 * share_rates_form_buy_value2;
		cost += inschijf3 * share_rates_form_buy_value3;
		cost += quantity * share_rates_form_buy_value4;
		}
	if( (buy_from_type == FIELD_VALUE) && (buy_value_type == FIELD_PERCENTAGE) )
		{
		/* money in schijf, percentage in value, results in money */
		cost += inschijf1 * (share_rates_form_buy_value1 / 100.0);
		cost += inschijf2 * (share_rates_form_buy_value2 / 100.0);
		cost += inschijf3 * (share_rates_form_buy_value3 / 100.0);
		cost += quantity * (share_rates_form_buy_value4 / 100.0);
		}

	if(debug_flag)
		{
		fprintf(stdout, "get_share_transaction_cost():\n\
		schijf1=%.2f schijf2=%.2f schijf3=%.2f\n",\
		schijf1, schijf2, schijf3);

		fprintf(stdout, "get_share_transaction_cost():\n\
		inschijf1=%.2f inschijf2=%.2f inschijf3=%.2f above=%.2f\n",\
		inschijf1, inschijf2, inschijf3, quantity);
		}		

	if(share_rates_form_buy_minimum_field_type == FIELD_PERCENTAGE)
		{
		if(transaction_price < share_rates_form_buy_minimum)
			{
			cost = transaction_price * (share_rates_form_buy_minimum / 100.0);
			}		
		}
	else if(share_rates_form_buy_minimum_field_type == FIELD_VALUE)
		{
		if(transaction_price < share_rates_form_buy_minimum)
			{
			cost = share_rates_form_buy_minimum;
			}
		}
	else if(share_rates_form_buy_minimum_field_type == FIELD_QUANTITY)
		{
		fl_show_alert("Illegal entry in", "buy minimum field", "aborting", 1); 
		return(0);
		}

	if(share_rates_form_buy_fixed_field_type == FIELD_PERCENTAGE)
		{
		cost += transaction_price * (share_rates_form_buy_fixed / 100.0); 
		} 
	else if(share_rates_form_buy_fixed_field_type == FIELD_VALUE)
		{
		cost += share_rates_form_buy_fixed;
		}
	else if(share_rates_form_buy_fixed_field_type == FIELD_QUANTITY)
		{
		fl_show_alert("Illegal entry in", "buy fixed field", "aborting", 1); 
		return(0);
		}

	*transaction_cost = cost;

	if(debug_flag)
		{
		fprintf(stdout, "get_share_transaction_cost():\n\
		mode=%d transaction_quantity=%.2f share_price=%.2f transaction_price=%.2f\n\
		calculated transaction_cost=%.2f\n",\
		mode, transaction_quantity, share_price, transaction_price,\
		*transaction_cost);

		}/* end if debug_flag */

	return(1);
	}/* end in mode == BUY */
if(mode == SELL)
	{
	if(sell_from_type == FIELD_VALUE) quantity = transaction_price;
	else if(sell_from_type == FIELD_QUANTITY) quantity = transaction_quantity;
	else
		{
		fl_show_alert(\
		"Illegal entry in 'SELL from'", "in rates form", "", 1);	
		return(0);
		}

	if( (sell_value_type != FIELD_PERCENTAGE) &&\
	(sell_value_type != FIELD_VALUE) )
		{
		fl_show_alert(\
		"Illegal entry in 'SELL value'", "in rates form", "", 1);
		return(0);
		}

	schijf1 = share_rates_form_sell_from2 - share_rates_form_sell_from1;
	schijf2 = share_rates_form_sell_from3 - share_rates_form_sell_from2;
	schijf3 = share_rates_form_sell_from4 - share_rates_form_sell_from3;

	inschijf1 = inschijf2 = inschijf3 = 0;

	if(quantity < schijf1) {inschijf1 = quantity; quantity = 0;}
	else {inschijf1 = schijf1; quantity -= schijf1;}
	if(quantity > 0)
		{
		if(quantity < schijf2) {inschijf2 = quantity; quantity = 0;}
		else {inschijf2 = schijf2; quantity -= schijf2;}
		if(quantity > 0)
			{	
			if(quantity < schijf3) {inschijf3 = quantity; quantity = 0;}
			else {inschijf3 = schijf3; quantity -= schijf3;}
			}		
		}
	if(quantity < 0) quantity = 0;

	if( (sell_from_type == FIELD_QUANTITY) && (sell_value_type == FIELD_VALUE) )
		{
		/* quantity in schijf, money in value */
		cost += inschijf1 * share_rates_form_sell_value1;
		cost += inschijf2 * share_rates_form_sell_value2;
		cost += inschijf3 * share_rates_form_sell_value3;
		cost += quantity * share_rates_form_sell_value4;
		}
	if( (sell_from_type == FIELD_QUANTITY) && (sell_value_type == FIELD_PERCENTAGE) )
		{
		/* quantity in schijf, percentage transaction in value */
		cost += inschijf1 * share_price * (share_rates_form_sell_value1 / 100.0);
		cost += inschijf2 * share_price * (share_rates_form_sell_value2 / 100.0);
		cost += inschijf3 * share_price * (share_rates_form_sell_value3 / 100.0);
		cost += quantity * share_price * (share_rates_form_sell_value4 / 100.0);
		}
	if( (sell_from_type == FIELD_VALUE) && (sell_value_type == FIELD_VALUE) )
		{
		/* money in in schijf, money in value, results in problem? */
		/* say: 4 $ for the first 1000$, 3$ for above 1000$ */
		cost += inschijf1 * share_rates_form_sell_value1;
		cost += inschijf2 * share_rates_form_sell_value2;
		cost += inschijf3 * share_rates_form_sell_value3;
		cost += quantity * share_rates_form_sell_value4;
		}
	if( (sell_from_type == FIELD_VALUE) && (sell_value_type == FIELD_PERCENTAGE) )
		{
		/* money in schijf, percentage in value, results in money */
		cost += inschijf1 * (share_rates_form_sell_value1 / 100.0);
		cost += inschijf2 * (share_rates_form_sell_value2 / 100.0);
		cost += inschijf3 * (share_rates_form_sell_value3 / 100.0);
		cost += quantity * (share_rates_form_sell_value4 / 100.0);
		}

	if(debug_flag)
		{
		fprintf(stdout, "get_share_transaction_cost():\n\
		schijf1=%.2f schijf2=%.2f schijf3=%.2f\n",\
		schijf1, schijf2, schijf3);

		fprintf(stdout, "get_share_transaction_cost():\n\
		inschijf1=%.2f inschijf2=%.2f inschijf3=%.2f above=%.2f\n",\
		inschijf1, inschijf2, inschijf3, quantity);
		}		

	if(share_rates_form_sell_minimum_field_type == FIELD_PERCENTAGE)
		{
		if(transaction_price < share_rates_form_sell_minimum)
			{
			cost = transaction_price * (share_rates_form_sell_minimum / 100.0);
			}		
		}
	else if(share_rates_form_sell_minimum_field_type == FIELD_VALUE)
		{
		if(transaction_price < share_rates_form_sell_minimum)
			{
			cost = share_rates_form_sell_minimum;
			}
		}
	else if(share_rates_form_sell_minimum_field_type == FIELD_QUANTITY)
		{
		fl_show_alert("Illegal entry in", "sell minimum field", "aborting", 1); 
		return(0);
		}

	if(share_rates_form_sell_fixed_field_type == FIELD_PERCENTAGE)
		{
		cost += transaction_price * (share_rates_form_sell_fixed / 100.0); 
		} 
	else if(share_rates_form_sell_fixed_field_type == FIELD_VALUE)
		{
		cost += share_rates_form_sell_fixed;
		}
	else if(share_rates_form_sell_fixed_field_type == FIELD_QUANTITY)
		{
		fl_show_alert("Illegal entry in", "sell fixed field", "aborting", 1); 
		return(0);
		}

	*transaction_cost = cost;

	if(debug_flag)
		{
		fprintf(stdout, "get_share_transaction_cost():\n\
		mode=%d transaction_quantity=%.2f share_price=%.2f transaction_price=%.2f\n\
		calculated transaction_cost=%.2f\n",\
		mode, transaction_quantity, share_price, transaction_price,\
		*transaction_cost);

		}/* end if debug_flag */

	return(1);
	}/* end if mode == SELL */
/* invalid mode */
return(0);
}/* end function get_share_transaction_cost */


