#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <strings.h>

int debug_flag = 0;

int main(int argc, char **argv)
{
int a, i;
char filebody[512];
float fa, fb, fc;
char ti[1024];
char to[1024];
char ta[1024];
FILE *krsf, *krsfb;
char path[512];
float multiplic_factor;
char fiwd[10], fimo[10];
int fida;/*day in header stockfile*/
float fmink, fmaxk;
int xpos,ypos,lenfie,lenfr;
int pg,sp,af;/*page subpage acq flag*/
char si[80];
char comstr[21];/*comment string for .krs file*/ 
float trend;

fprintf(stdout, "\nSplit stock value file, fundname? ");
fscanf(stdin, "%8s", filebody);
fprintf(stdout, "\nOld stockprice? ");
fscanf(stdin, "%f", &fa);
fprintf(stdout, "\nNew stockprice? ");
fscanf(stdin, "%f", &fb);

multiplic_factor = fb / fa;
fprintf(stdout, "\nSplit factor = %4.2f", multiplic_factor);

get_path_name("stock_files_dir", path);
sprintf(ti, "%s%s.krs", path, filebody);
sprintf(to, "%s%s.tmp", path, filebody);
sprintf(ta, "%s%s.bak", path, filebody);

/* open output file */
krsf = fopen(to, "w");/*krsf is fundname.tmp, dest*/
if(!krsf)
	{
	fprintf(stdout, "\nCannot open file %s for write", to);
	exit(EXIT_FAILURE);
	}
/* open input file */
krsfb = fopen(ti, "r");/*krsfb is fundname.krs, source*/
if(!krsfb)
	{
	fprintf(stdout, "\nCannot open file %s for read",ti);
	fclose(krsf);/*temp was open*/
	exit(EXIT_FAILURE);
	}
fprintf(stdout, "\nSplitting file %s" ,ti);

/*input file now open */

/* read header */
fscanf(krsfb,\
"%s %s %d %s %f %d %d %d %d %d %d %f %f %d",\
fiwd, fimo, &fida, si, &trend, &af, &pg, &sp, &xpos, &ypos,\
&lenfie, &fmaxk, &fmink, &lenfr);

/* divide max and min by multiplic_factor */
fmaxk *= multiplic_factor;
fmink *= multiplic_factor;

/* write header to new file */
fprintf(krsf,\
"%s %s %d %s %4.2f %d %d %d %d %d %d %4.2f %4.2f %d ",\
fiwd, fimo, fida, si, trend, af, pg, sp, xpos, ypos,\
lenfie, fmaxk, fmink, lenfr);

/* copy fields from inputfile .krs , modify stock values*/
fa = 0;/*reset text type flag*/
while(1)
	{
	a = fscanf(krsfb, "%20s ", comstr);/* read in as string */
	if(a == -1)break;/*EOF*/

	fa = atof(comstr);/* convert to float */
	 /* fa is 0 for non digits,
	 /* -1 for special fields,
	 /* > 0 for stock values */
	if(fa > 0)/*stock value read*/
		{
		fa *= multiplic_factor;/* multiply stock value */
		fprintf(krsf, "%4.2f ", fa);/* copy as float */
		}
	else /*not a stock value */
		{
		fprintf(krsf, "%s ", comstr);/* copy as string */
		}
	}/*end while copy all entries as string*/

/* mark the file for split*/
fprintf(krsf, "-4 split%4.2f ", multiplic_factor);

/* close files */
fclose(krsfb);/* close source */
fclose(krsf);/* close dest */

/*erase any existing .bak file*/
unlink(ta);

/* rename .krs into .bak file */
i = rename(ti, ta);
if(i == -1)
	{
	fprintf(stdout, "\nCannot rename file %s into %s\n",	ti, ta);
	exit(EXIT_FAILURE);
	}
/* rename .tmp into .krs file */
i = rename(to, ti);
if(i == -1)
	{
	fprintf(stdout, "\nCannot rename file %s into %s\n",	to,ti);
	exit(EXIT_FAILURE);
	}
fprintf(stdout,\
"\nReady, file %s has been split by factor %4.2f\n",\
ti, multiplic_factor);

exit(EXIT_SUCCESS);
}/* end function main */


int get_path_name(char *request, char *reply)
/* reply is directory for requested type of file */
{
FILE *inifile;
int a, i;
char filename[40];
int flags[10];
char idfield[40], contentfield[40];
char database_dir[40];
char macro_files_dir[40];
char ir_remote_command_files_dir[40];
char acq_command_files_dir[40];
char stock_files_dir[40];
char error_files_dir[40];

if(debug_flag)
	{
	fprintf(stdout, "get_path_name(): arg request=%s\n", request);
	}

if(! request) return(0);

sprintf(filename, "/etc/krs/krs.ini");
inifile = fopen(filename, "r");
if(! inifile)
	{
	fprintf(stdout,\
	"get_path_name(): cannot open file %s for read\n", filename);
	return(0);

	strcpy(database_dir, "/teletext/");
	strcpy(macro_files_dir, "/etc/krs/");
	strcpy(ir_remote_command_files_dir, "/etc/krs/");
	strcpy(acq_command_files_dir, "/etc/krs/");
	strcpy(stock_files_dir, "/etc/krs/");
	strcpy(error_files_dir, "/etc/krs/");
	}
else /* reading from /etc/krs/krs.ini */
	{
	while(1)
		{
		a = fscanf(inifile, "%s %s", idfield, contentfield);
		if(a == EOF)break;
		if(strstr(idfield, "[database_files]") == idfield)
			{
			strcpy(database_dir, contentfield);
			flags[0] =1;
			}
		if(strstr(idfield, "[macro_files]") == idfield)
			{		
			strcpy(macro_files_dir, contentfield);
			flags[1] = 1;
			}
		if(strstr(idfield, "[ir_remote_command_files]") == idfield)
			{
			strcpy(ir_remote_command_files_dir, contentfield);
			flags[2] = 1;
			}
		if(strstr(idfield, "[acq_command_files]") == idfield)
			{
			strcpy(acq_command_files_dir, contentfield);
			flags[3] = 1;
			}
		if(strstr(idfield, "[stock_files]") == idfield)
			{
			strcpy(stock_files_dir, contentfield);
			flags[4] = 1;
			}
		if(strstr(idfield, "[error_files]") == idfield)
			{
			strcpy(error_files_dir, contentfield);
			flags[5] = 1;
			}		
		}/* end while read from file */
	for(i = 0; i < 6; i++)
		{
		if(flags[i] != 1)
			{
			fprintf(stdout, "get_path_name(): file format error field %d", i);
			}
		}
	fclose(inifile);
	}/* end reading from krs.ini */
/* reply */
if(strcmp("database_files_dir", request) == 0)\
	strcpy(reply, database_dir);
else if(strcmp("macro_files_dir", request) == 0)\
	strcpy(reply, macro_files_dir);
else if(strcmp("ir_remote_command_files_dir", request) == 0)\
	strcpy(reply, ir_remote_command_files_dir);
else if(strcmp("acq_command_files_dir", request) == 0)\
	strcpy(reply, acq_command_files_dir);
else if(strcmp("stock_files_dir", request) == 0)\
	strcpy(reply, stock_files_dir);
else if(strcmp("error_files_dir", request) == 0)\
	strcpy(reply, error_files_dir);
else if(inifile)/* error in krs.ini */
	{
	fprintf(stdout, "get_path_name(): Error in /etc/krs/krs.ini\n");
	if(strcmp("database_files_dir", request) == 0)strcpy(reply, "/teletext/");
	else strcpy(reply,"/etc/krs/");/* use if error in inifile */
	}

return(1);
}/* end function get_path_name */


