/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "xkra.h"

FD_xkra *fdui;

extern FD_xkra *fd_main_form;

int fontsizes_modified_flag;
int transaction_add_form_modified_flag;

int transaction_year;
int transaction_month;
int transaction_hour;
int transaction_day;
int transaction_buy_sell;
char transaction_fund[512];
int transaction_type;
int transaction_expiration_year;
int transaction_expiration_month;
float transaction_strikeprice;
float transaction_price;
float transaction_quantity;
float transaction_account;

void transaction_add_form_year_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

transaction_year = atoi(ptr);
if(transaction_year < 1900) 
	{
	fl_set_focus_object(fd_main_form -> transaction_add_form, ob);
	fl_show_alert("Illegal year", ptr, "use: > 1900", 1);
	return;
	}

} /* end function transaction_add_form_year_input_field_cb */


void transaction_add_form_month_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

if(isdigit(ptr[0]) )
	{
	transaction_month = atoi(ptr);
	}
else
	{
	transaction_month = month_to_digit(ptr);
	}

if( (transaction_month < 1) || (transaction_month > 12) )
	{
	fl_set_focus_object(fd_main_form -> transaction_add_form, ob);
	fl_show_alert("Illegal month", ptr, "Use 1 - 12 or jan feb ..", 1);
	return;
	}
} /* end function transaction_add_form_month_input_field_cb */


void transaction_add_form_day_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

transaction_day = atoi(ptr);
if( (transaction_day < 1) || (transaction_day > 31) )
	{
	fl_set_focus_object(fd_main_form -> transaction_add_form, ob);
	fl_show_alert("Illegal day", ptr, "use: 1 through 31", 1);
	return;
	}

} /* end function transaction_add_form_day_input_field_cb */


void transaction_add_form_hour_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

transaction_hour = atoi(ptr);
if( (transaction_hour < 0) || (transaction_hour > 24) )
	{
	fl_set_focus_object(fd_main_form -> transaction_add_form, ob);
	fl_show_alert("Illegal hour", ptr, "use: 0 through 24", 1);
	return;
	}

} /* end function transaction_add_form_hour_input_field_cb */


void transaction_add_form_fund_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

if( (strlen(ptr) == 0) || (strlen(ptr) > 40) )
	{
	fl_set_focus_object(fd_main_form -> transaction_add_form, ob);
	fl_show_alert("Illegal fundname", ptr, "Use 1 - 40 characters max.", 1);
	return;
	}

strcpy(transaction_fund, ptr);

} /* end function transaction_add_form_fund_input_field_cb */


void transaction_add_form_type_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

if(strcasecmp(ptr, "stock") == 0)
	{
	transaction_type = TYPE_STOCK;
	}
else if(strcasecmp(ptr, "call") == 0)
	{
	transaction_type = TYPE_CALL;
	}
else if(strcasecmp(ptr, "put") == 0)
	{
	transaction_type = TYPE_PUT;
	}
else if(strcasecmp(ptr, "bond") == 0)
	{
	transaction_type = TYPE_BOND;
	}
else
	{
	fl_set_focus_object(fd_main_form -> transaction_add_form, ob);
	fl_show_alert("Illegal type", ptr, "use: stock call put bond", 1);
	return;
	}

} /* end function transaction_add_form_type_input_field_cb */


void transaction_add_form_expiration_month_input_field_cb(\
	FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

if(isdigit(ptr[0]) )
	{
	transaction_expiration_month = atoi(ptr);
	}
else
	{
	transaction_expiration_month = month_to_digit(ptr);
	}		

if( (transaction_expiration_month < 1) ||\
	(transaction_expiration_month > 12) )
	{
	fl_set_focus_object(fd_main_form -> transaction_add_form, ob);
	fl_show_alert(\
		"Illegal expiration month", ptr, "Use 1 - 12 or jan feb ..", 1);
	return;
	}
} /* end function transaction_add_form_expiration_month_input_field_cb */


void transaction_add_form_expiration_year_input_field_cb(\
	FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

transaction_expiration_year = atoi(ptr);
if(transaction_expiration_year < 1999) 
	{
	fl_set_focus_object(fd_main_form -> transaction_add_form, ob);
	fl_show_alert("Illegal expiration year", ptr, "use: > 1999", 1);
	return;
	}

} /* end function transaction_add_form_expiration_year_input_field_cb */


void transaction_add_form_strikeprice_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

transaction_strikeprice = atof(ptr);
if(transaction_strikeprice <= 0)
	{
	fl_set_focus_object(fd_main_form -> transaction_add_form, ob);
	fl_show_alert("Illegal strikeprice", ptr, "use: >= 0", 1);
	return;
	}

} /* end function transaction_add_form_strikeprice_input_field_cb */


void transaction_add_form_quantity_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

transaction_quantity = atof(ptr);
if(transaction_quantity <= 0)
	{
	fl_set_focus_object(fd_main_form -> transaction_add_form, ob);
	fl_show_alert("Illegal transaction quantity", ptr, "use: >= 0", 1);
	}

} /* end function transaction_add_form_quantity_input_field_cb */


void transaction_add_form_account_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;
/* can be zero or negative, but must be something */
if(strlen(ptr) == 0)
	{
	fl_set_focus_object(fd_main_form -> transaction_add_form, ob);
	fl_show_alert("No account value specified", ptr, "using zero", 1);
	transaction_account = 0.0;
	}
transaction_account = atof(ptr);

} /* end function transaction_add_form_account_input_field_cb */


void transaction_add_form_price_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

transaction_price = atof(ptr);
if(transaction_price <= 0)
	{
	fl_set_focus_object(fd_main_form -> transaction_add_form, ob);
	fl_show_alert("Illegal price", ptr, "use: >= 0", 1);
	return;
	}
} /* end function transaction_add_form_price_input_field_cb */


void transaction_add_form_buy_button_cb(FL_OBJECT *ob, long data)
{
transaction_buy_sell = BUY;
} /* end function transaction_add_form_buy_button_cb */


void transaction_add_form_sell_button_cb(FL_OBJECT *ob, long data)
{
transaction_buy_sell = SELL;
} /* end function transaction_add_form_sell_button_cb */


void transaction_add_form_clear_button_cb(FL_OBJECT *ob, long data)
{
fl_set_input(fdui -> transaction_add_form_year_input_field, "");
fl_set_input(fdui -> transaction_add_form_month_input_field, "");
fl_set_input(fdui -> transaction_add_form_day_input_field, "");
fl_set_input(fdui -> transaction_add_form_hour_input_field, "");
fl_set_input(fdui -> transaction_add_form_fund_input_field, "");
fl_set_input(fdui -> transaction_add_form_type_input_field, "");
fl_set_input(fdui -> transaction_add_form_expiration_month_input_field, "");
fl_set_input(fdui -> transaction_add_form_expiration_year_input_field, "");
fl_set_input(fdui -> transaction_add_form_strikeprice_input_field, "");
fl_set_input(fdui -> transaction_add_form_account_input_field, "");

fl_set_input(fdui -> transaction_add_form_quantity_input_field, "");
fl_set_input(fdui -> transaction_add_form_price_input_field, "");

} /* end function transaction_add_form_clear_button_cb */


void transaction_add_form_cancel_button_cb(FL_OBJECT *ob, long data)
{
fl_hide_form(fdui -> transaction_add_form);

/* do nothing */

transaction_add_form_shown_flag = 0;
} /* end function transaction_add_form_cancel_button_cb */


void transaction_add_form_accept_button_cb(FL_OBJECT *ob, long data)
{
char report[512];

if(! add_transaction_to_transaction_list(\
transaction_year, transaction_month, transaction_day, transaction_hour, \
transaction_buy_sell, transaction_fund, transaction_type,\
transaction_expiration_month, transaction_expiration_year,\
transaction_strikeprice, transaction_quantity, transaction_price,\
transaction_account, report) )
	{
	fl_show_alert("Cannot add transaction", report, "", 1);
	return;
	}

fl_hide_form(fdui -> transaction_add_form);

portfolio_form_modified_flag = 1;

transaction_add_form_shown_flag = 0;
} /* end function transaction_add_form_accept_button_cb */

