/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef FD_xkra_h_
#define FD_xkra_h_

#include <forms.h>

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <sys/time.h>
#include <signal.h>
#include <setjmp.h>
#include <pwd.h>
#include <math.h>
#include <time.h>
#include <sys/stat.h>

#include "xkra_proto.h"
#include "statistic_proto.h"
#include "black_scholes_proto.h"
#include "options_proto.h"


typedef struct {
	FL_FORM *main_form;
	FL_FORM *share_rates_form;
	FL_FORM *option_rates_form;
	FL_FORM *option_calculator_form;
	FL_FORM *portfolio_form;
	FL_FORM *transaction_add_form;
	FL_FORM *option_evaluation_form;
	
	FL_OBJECT *main_form_window_menu;
	FL_OBJECT *ixyplot;
	FL_OBJECT *info_light;
	FL_OBJECT *fund_input;
	FL_OBJECT *directory_input;
	FL_OBJECT *outfield;
	FL_OBJECT *volumefield;
	FL_OBJECT *close_switch;
	FL_OBJECT *volume_switch;
	FL_OBJECT *start_input;
	FL_OBJECT *end_input;
	FL_OBJECT *moving_average_1_switch;
	FL_OBJECT *ma1_input;
	FL_OBJECT *moving_average_2_switch;
	FL_OBJECT *ma2_input;
	FL_OBJECT *mawei1_input;
	FL_OBJECT *mawei2_input;
	FL_OBJECT *text_switch;
	FL_OBJECT *upper_switch;
	FL_OBJECT *lower_switch;
	FL_OBJECT *exit_switch;
	FL_OBJECT *local_clock;
	FL_OBJECT *new_york_clock;
	FL_OBJECT *ny_clock_id;
	FL_OBJECT *file_type_switch;
	FL_OBJECT *relative_strength_switch;
	FL_OBJECT *update_switch;
	FL_OBJECT *relative_file_input;
	FL_OBJECT *auto_trade_switch;
	FL_OBJECT *momentum_switch;
	FL_OBJECT *momentum_days_input;
	FL_OBJECT *ma1_lead_input;
	FL_OBJECT *ma2_lead_input;
	FL_OBJECT *simulation_switch;
	FL_OBJECT *decision_switch;
	FL_OBJECT *vermogen_switch;
	FL_OBJECT *shares_switch;
	FL_OBJECT *start_capital_input;
	FL_OBJECT *optimize_button;

	FL_OBJECT *option_evaluation_form_title;
	FL_OBJECT *option_evaluation_form_import_menu;
	FL_OBJECT *option_evaluation_form_filter_input_field;
	FL_OBJECT *option_evaluation_form_filter_case_button;
	FL_OBJECT *option_evaluation_form_filter_clear_button;
	FL_OBJECT *option_evaluation_form_option_browser;
	FL_OBJECT *option_evaluation_form_status_display;
	FL_OBJECT *option_evaluation_form_fontsize_up_button;
	FL_OBJECT *option_evaluation_form_fontsize_down_button;
	FL_OBJECT *option_evaluation_form_cancel_button;
	FL_OBJECT *option_evaluation_form_accept_button;
	
	FL_OBJECT *transaction_add_form_title;	
	FL_OBJECT *transaction_add_form_date_text;
	FL_OBJECT *transaction_add_form_fund_text;
	FL_OBJECT *transaction_add_form_year_input_field;
	FL_OBJECT *transaction_add_form_month_input_field;
	FL_OBJECT *transaction_add_form_day_input_field;
	FL_OBJECT *transaction_add_form_hour_input_field;
	FL_OBJECT *transaction_add_form_fund_input_field;
	FL_OBJECT *transaction_add_form_type_input_field;
	FL_OBJECT *transaction_add_form_expiration_month_input_field;
	FL_OBJECT *transaction_add_form_expiration_year_input_field;
	FL_OBJECT *transaction_add_form_strikeprice_input_field;
	FL_OBJECT *transaction_add_form_account_input_field;
	FL_OBJECT *transaction_add_form_quantity_input_field;
	FL_OBJECT *transaction_add_form_price_input_field;
	FL_OBJECT *transaction_add_form_buy_button;
	FL_OBJECT *transaction_add_form_sell_button;
	FL_OBJECT *transaction_add_form_clear_button;
	FL_OBJECT *transaction_add_form_accept_button;
	FL_OBJECT *transaction_add_form_cancel_button;

	FL_OBJECT *portfolio_form_title;
	FL_OBJECT *portfolio_form_update_menu;
	FL_OBJECT *portfolio_form_chart_menu;
	FL_OBJECT *portfolio_form_import_menu;
	FL_OBJECT *portfolio_form_value_input_field;
	FL_OBJECT *portfolio_form_cash_input_field;
	FL_OBJECT *portfolio_form_market_filter_input_field;
	FL_OBJECT *portfolio_form_market_filter_case_button;
	FL_OBJECT *portfolio_form_market_filter_clear_button;
	FL_OBJECT *portfolio_form_transaction_filter_input_field;
	FL_OBJECT *portfolio_form_transaction_filter_case_button;
	FL_OBJECT *portfolio_form_transaction_filter_clear_button;
	FL_OBJECT *portfolio_form_market_browser;
	FL_OBJECT *portfolio_form_transaction_browser;
	FL_OBJECT *portfolio_form_browser_select_button;
	FL_OBJECT *portfolio_form_show_owned_only_button;
	FL_OBJECT *portfolio_form_sort_alpha_button;
	FL_OBJECT *portfolio_form_sort_price_button;
	FL_OBJECT *portfolio_form_price_input_field;
	FL_OBJECT *portfolio_form_buy_button;
	FL_OBJECT *portfolio_form_sell_button;
	FL_OBJECT *portfolio_form_delete_item_button;
	FL_OBJECT *portfolio_form_delete_transaction_button;
	FL_OBJECT *portfolio_form_clear_button;
	FL_OBJECT *portfolio_form_delete_expired_button;
	FL_OBJECT *portfolio_form_add_item_button;
	FL_OBJECT *portfolio_form_add_transaction_button;
	FL_OBJECT *portfolio_form_quantity_input_field;
	FL_OBJECT *portfolio_form_fund_input_field;
	FL_OBJECT *portfolio_form_type_input_field;
	FL_OBJECT *portfolio_form_month_input_field;
	FL_OBJECT *portfolio_form_year_input_field;
	FL_OBJECT *portfolio_form_strikeprice_input_field;
	FL_OBJECT *portfolio_form_market_group_fontsize_up_button;
	FL_OBJECT *portfolio_form_market_group_fontsize_down_button;
	FL_OBJECT *portfolio_form_transaction_group_fontsize_up_button;
	FL_OBJECT *portfolio_form_transaction_group_fontsize_down_button;
	FL_OBJECT *portfolio_form_status_display;
	FL_OBJECT *portfolio_form_pie_chart;
	FL_OBJECT *portfolio_form_special_pie_chart;
	FL_OBJECT *portfolio_form_bar_chart;
	FL_OBJECT *portfolio_form_accept_button;
	FL_OBJECT *portfolio_form_cancel_button;
	FL_OBJECT *portfolio_form_market_group;
	FL_OBJECT *portfolio_form_transaction_group;
	
	FL_OBJECT *option_calculator_form_title;
	FL_OBJECT *option_calculator_form_fundname_input_field;
	FL_OBJECT *option_calculator_form_month_input_field;
	FL_OBJECT *option_calculator_form_year_input_field;
	FL_OBJECT *option_calculator_form_strike_price_input_field;
	FL_OBJECT *option_calculator_form_days_to_expiration_input_field;
	FL_OBJECT *option_calculator_form_days_to_expiration_button;
	FL_OBJECT *option_calculator_form_current_riskfree_interest_rate_input_field;
	FL_OBJECT *option_calculator_form_current_riskfree_interest_rate_button;
	FL_OBJECT *option_calculator_form_riskfree_interest_file_input_field;
	FL_OBJECT *option_calculator_form_current_stock_price_input_field;
	FL_OBJECT *option_calculator_form_current_stock_price_button;
	FL_OBJECT *option_calculator_form_daily_standard_deviation_input_field;
	FL_OBJECT *option_calculator_form_daily_standard_deviation_button;
	FL_OBJECT *option_calculator_form_data_points_input_field;
	FL_OBJECT *option_calculator_form_yearly_standard_deviation_input_field;
	FL_OBJECT *option_calculator_form_yearly_standard_deviation_button;
	FL_OBJECT *option_calculator_form_present_call_value_input_field;
	FL_OBJECT *option_calculator_form_present_put_value_input_field;
	FL_OBJECT *option_calculator_form_accept_button;
	FL_OBJECT *option_calculator_form_cancel_button;

	FL_OBJECT *share_rates_form_title;
	FL_OBJECT *share_rates_form_buy_text;
	FL_OBJECT *share_rates_form_sell_text;
	FL_OBJECT *share_rates_form_buy_minimum_input_field;
	FL_OBJECT *share_rates_form_buy_from1_input_field;
	FL_OBJECT *share_rates_form_buy_value1_input_field;
	FL_OBJECT *share_rates_form_buy_from2_input_field;
	FL_OBJECT *share_rates_form_buy_value2_input_field;
	FL_OBJECT *share_rates_form_buy_from3_input_field;
	FL_OBJECT *share_rates_form_buy_value3_input_field;
	FL_OBJECT *share_rates_form_buy_from4_input_field;
	FL_OBJECT *share_rates_form_buy_value4_input_field;
	FL_OBJECT *share_rates_form_buy_fixed_input_field;
	FL_OBJECT *share_rates_form_sell_minimum_input_field;
	FL_OBJECT *share_rates_form_sell_from1_input_field;
	FL_OBJECT *share_rates_form_sell_value1_input_field;
	FL_OBJECT *share_rates_form_sell_from2_input_field;
	FL_OBJECT *share_rates_form_sell_value2_input_field;
	FL_OBJECT *share_rates_form_sell_from3_input_field;
	FL_OBJECT *share_rates_form_sell_value3_input_field;
	FL_OBJECT *share_rates_form_sell_from4_input_field;
	FL_OBJECT *share_rates_form_sell_value4_input_field;
	FL_OBJECT *share_rates_form_sell_fixed_input_field;
	FL_OBJECT *share_rates_form_include_button;
	FL_OBJECT *share_rates_form_fontsize_up_button;
	FL_OBJECT *share_rates_form_fontsize_down_button;
	FL_OBJECT *share_rates_form_currency_symbol_input_field;
	FL_OBJECT *share_rates_form_accept_button;
	FL_OBJECT *share_rates_form_cancel_button;

	FL_OBJECT *option_rates_form_title;
	FL_OBJECT *option_rates_form_buy_text;
	FL_OBJECT *option_rates_form_sell_text;
	FL_OBJECT *option_rates_form_buy_minimum_input_field;
	FL_OBJECT *option_rates_form_buy_from1_input_field;
	FL_OBJECT *option_rates_form_buy_value1_input_field;
	FL_OBJECT *option_rates_form_buy_from2_input_field;
	FL_OBJECT *option_rates_form_buy_value2_input_field;
	FL_OBJECT *option_rates_form_buy_from3_input_field;
	FL_OBJECT *option_rates_form_buy_value3_input_field;
	FL_OBJECT *option_rates_form_buy_from4_input_field;
	FL_OBJECT *option_rates_form_buy_value4_input_field;
	FL_OBJECT *option_rates_form_buy_fixed_input_field;
	FL_OBJECT *option_rates_form_sell_minimum_input_field;
	FL_OBJECT *option_rates_form_sell_from1_input_field;
	FL_OBJECT *option_rates_form_sell_value1_input_field;
	FL_OBJECT *option_rates_form_sell_from2_input_field;
	FL_OBJECT *option_rates_form_sell_value2_input_field;
	FL_OBJECT *option_rates_form_sell_from3_input_field;
	FL_OBJECT *option_rates_form_sell_value3_input_field;
	FL_OBJECT *option_rates_form_sell_from4_input_field;
	FL_OBJECT *option_rates_form_sell_value4_input_field;
	FL_OBJECT *option_rates_form_sell_fixed_input_field;
	FL_OBJECT *option_rates_form_include_button;
	FL_OBJECT *option_rates_form_fontsize_up_button;
	FL_OBJECT *option_rates_form_fontsize_down_button;
	FL_OBJECT *option_rates_form_currency_symbol_input_field;
	FL_OBJECT *option_rates_form_accept_button;
	FL_OBJECT *option_rates_form_cancel_button;
} FD_xkra;

extern FD_xkra *create_form_main_form(void);
extern FD_xkra *create_form_rates_form(void);
extern FD_xkra *create_form_option_calculator_form(void);
extern FD_xkra *create_form_portfolio_form(void);
extern FD_xkra *create_form_option_evaluation_form(void);

#define DATA_SIZE	8192
#define READSIZE	65535
#define TEMP_SIZE	65535

#define MAX_MADAY1	1000
#define MAX_MADAY2	1000

#define GOLD_CROSS	1
#define DEAD_CROSS	2
#define NO_CROSS	3
#define MAXIMUM		4
#define MINIMUM		5
#define BUY			7
#define SELL		8
#define HOLD		9

#define GOLD_DEAD	0/* do not change this to 1, see decision_switch_cb() */
#define MAX_MIN		1
/* add your own scheme indentifiers here */
 
/* for sorting */
#define SORT_ALPHA	1
#define SORT_PRICE	2
#define SORT_DATE	3

/* for portfolio form */
#define TYPE_UNKOWN	0
#define TYPE_STOCK	1
#define TYPE_CALL	2
#define TYPE_PUT	3
#define TYPE_BOND	4

/* for position browser display */
#define SHOW_TOP			0
#define SHOW_SAME_POSITION	1
#define SHOW_UNREAD_AT_TOP	2
#define SHOW_BOTTOM			3

/* for items in portfolio browser */
#define NEW_ITEM	0
#define HAVE_ITEM	1

/* for portfolio form browser select */
#define MARKET_BROWSER			1
#define TRANSACTION_BROWSER		2

/* portfolio form update menu */
#define UPDATE_KRS_FILES_FROM_PORTFOLIO				1
#define UPDATE_KRS_FILES_FROM_FASTSERVICE_EMAIL		2

/* portfolio form chart menu */
#define WHERE_YOUR_MONEY_IS		1
#define HIDE_CHARTS				2

/* for portfolio form import menu */
#define IMPORT_DAVIEFF_OPTIONS		1
#define IMPORT_DAVIEFF_SHARES		2
#define IMPORT_FASTSERVICE_EMAIL	3

/* for file_type in parsing davieff files */
#define OPTIONS_FILE	1
#define SHARES_FILE		2
#define BONDS_FILE		3

/* for main form window menu */
#define PORTFOLIO_MANAGEMENT	1
#define OPTION_CALCULATOR		2
#define SHARE_RATES				3
#define OPTION_RATES			4
#define OPTION_EVALUATOR		5

/* default time difference with New York */
#define NEW_YORK_OFFSET -6

/* some defaults */

int start;/* start of data from file */
int end;/* end of data from file, set after reading in file */
int maday1;/* moving average 1 (days) */
int maday2;/* moving average 2 (days) */
float mawei1;/* weighting for moving average 1 */
float mawei2;/* weighting for moving average 2 */
int close_flag;/* plot close prices */
int ma1_flag;/* plot moving average 1 */
int ma2_flag;/* plot moving average 2 */
int text_flag;/* print text in graph (month year, ex divident) */
int upper_flag;/* upper trading band display enable */
int lower_flag;/* lower trading band display enable */
int relative_flag;/* relative strength display enable */
int update_flag;/* automatic update uf data (reads data file) */
int file_loaded_flag;/* set if any file was loaded (valid data) */
int relative_file_loaded_flag;/* set if relative file loaded */
int file_type_flag;/* krs */
int auto_trade_flag;/* manual trading */
int optimize_flag;/* moving averages automatic optimize button */
char file_type[80];
char file_path[512];
int volume_flag;/* volume */
char relative_filename[80];/* all relatives to this */
int momentum_flag;/* plot momentum */
int momentum_days;/* days for momentum calculation */
int ma1_lead_days;/* leading days moving average 1 */
int ma2_lead_days;/* leading days moving average 2 */
float start_capital;
float start_shares;
float present_capital;
float present_shares;
int simulation_flag;/* activates simulation of buy / sell */
int decision_methode;
int vermogen_flag;/* vermogen */
int shares_flag;/* shares */
float gain;

int debug_flag;
char rates_path_filename[1024];
int share_rates_form_rates_read_flag;
int option_rates_form_rates_read_flag;
char moving_averages_path_filename[1024];
double dfyearly_standard_deviation;

int option_calculator_form_days_to_expiration_manual_input_flag;
int option_calculator_form_current_riskfree_interest_rate_manual_input_flag;
int option_calculator_form_current_stock_price_manual_input_flag;
int option_calculator_form_daily_standard_deviation_manual_input_flag;
int option_calculator_form_yearly_standard_deviation_manual_input_flag;
char *home_dir;
char *user_name;

int portfolio_form_sort_mode;
int portfolio_form_show_owned_only_flag;
int portfolio_form_market_filter_case_sensitive_flag;
int portfolio_form_transaction_filter_case_sensitive_flag;
float portfolio_form_value;
float portfolio_form_cash;
float portfolio_form_item_price;
float portfolio_form_quantity;
char *portfolio_form_fund;
int portfolio_form_type;
int portfolio_form_month;
int portfolio_form_year;
float portfolio_form_strikeprice;
int portfolio_form_selected_browser;
int directory_changed_flag;

int portfolio_form_shown_flag;
int option_calculator_form_shown_flag;
int share_rates_form_shown_flag;
int option_rates_form_shown_flag;
int transaction_add_form_shown_flag;
int option_evaluation_form_shown_flag;
int portfolio_form_modified_flag;

int option_evaluation_form_filter_case_sensitive_flag;

int portfolio_form_market_group_fontsize;
int portfolio_form_transaction_group_fontsize;
int share_rates_form_fontsize;
int option_rates_form_fontsize;
int option_evaluation_form_fontsize;

int new_york_offset;

char *option_evaluation_filename;
char *davieff_shares_filename;
char *davieff_options_filename;

int show_where_the_money_is_chart_shown_flag;

#define VERSION "xkra-0.9.5"

#endif /* FD_xkra_h_ */


