                      *xkra-0.9.5  MANUAL*
Usage: xkra

If the program complains about a non existing .mva file:
 Run 'optimize' for a while, then release it. 
 This will set the moving averages, and write the settings to disk as
 fund.mva.
 (for more info on optimize see below).

Install:
 Since you read this, you will already have done tar -zxvf xkra....tgz
 in a directory.
 Become root
 Now type:
 xmkmf
 That will create a Makefile for your system.
 To make the files:
 make
 make install
 make install.man

 Now create a directory in your home directory 
 mkdir ~/.xkra/
 cp xkrauser.tgz ~/.xkra/
 cd ~/.xkra 
 tar -zxvf xkrauser.tgz

 Since the manual is not formatted yet, best is to read xkra.man with
 your own favorite text editor.

What it can do:
The program uses 2 moving averages and the item price to make a decision.
It can find the best moving averages for you:
 Fill in 1 in m.a. 1 and 1 in m.a.2.
 Keep weight and lead zero.
 select 'cross' or 'max'.
 press 'sim' (enter simulation mode), 'shares' (show in red when you have 
 shares in your possession, 'verm' (from vermogen, total shares * share 
 value + cash, shown in blue), and fill in you start capital in s.cap
 Now press 'optimize'
 This takes ALL available CPU cycles.
 Keep the mouse near the optimize button, and press again when you see a
 gain you like in the bottom yellow field.
 The program fills in the best moving averages in the m.a.1 and m.a.2 field
 for you (and saves to disk in fund.mva for each fund).
 Also now the transaction are show, as these WOULD have occurred.
If you press 'upd' (from update), the program will read the file fund.krs
 once a minute, and if new data (update_funds running in another process) is
 available, you may get a buy / sell recommendation.
Of cause most people will just use the daily close prices, and once you
 get you best moving averages, you can just enter the fund name in the
'Fund' input field, and the program will still signal when a special 
 situation occurs.
But you could read new data every minute, and trade in real time, if
 you update fund.krs that frequent.
Portfolio management, an option calculator (Black and Scholes), option
 evaluator (calculates all the option valuses, and shows percentage that
 the current price is of these values), automatic fastservice email close
 price processing for daily updates, some chart, transaction browser.


What you should do:
If no action is required 'NO ACTION' is shown.
If you select 'cross', and a gold cross occurs, you will see 'GOLD CROSS'
(you need to buy). In the same way DEAD CROSS indicates you should sell.

If you select 'max', then MAXIMUM indicates you should sell, and MINIMUM
indicates you should buy.
 
Limitations:
The moving averages calculated (best solution found, all are tried), apply
only to past data.
Therefore there is NO GUARANTEE whatsoever that these values will yield
good results in the future.
However in practice results can be quite good, there is a tendency however
to not believe or go against the computer.
In that case the whole simulation is no longer valid.
You may find later that the computer was right anyways...

Peculiar results:
 If you started with m.a.1 = 1 and m.a.2 = 1, then it is very possible that
 the best solution is to just buy once and hold the shares.
 This saves transaction costs, and if the shares rise a lot, you will gain.
 Banks / brokers will disagree here, they make money from transactions,
 but just look at the ing example, it came from 15 to a peak of 70.
 Also note that 'splits' have been normalized here.
 And apart from this, there is also the dividend that you may miss if
 you just sold.
 Do as you think best.

More:
List of buttons and their meaning:
on the main_form;
info light:
fund input: the name of the fund (fund.krs)
out field
volume field: 
close button: enables the close price display.
volume button: enables the volume display.
start input: the display offset from the start of the data in the .krs file.
end input: the end of the display from the start of the .krs file.
ma1 button: enables the first moving average display. 
ma1 input: the fist moving average days setting. 
ma2 button: enables the second moving average display.
ma2 input: the second moving average days setting. 
weight1 input: the weighting input for the fist moving average.
weight2 input: the weighting input for the second moving average.
text button: enables the display of month, year, ex dividend in the graph.
upper button: enables the display of the upper trading band.
lower button: enables the display of the lower trading band.
exit button: exits the program.
local clock: show the local time.
New York clock: shows the time on Wall street
.krs button: selects between .krs and .csv type files.
rel button: enables the display of the relative strength.
upd button: reads file and runs the simulation every 10 seconds
		automatically.
relative file input: the name of the fund to compare again for relative
		strength.
auto_trade_button: 
momentum button: enables display of the momentum.
momentum days input: the number of days used for the momentum calculation.
ma1 lead input: offset in days used for moving average 1.
ma2 lead input: offset used in days for moving average 2.
sim button: enables simulation mode.
cross button: selects gold /dead cross or maximum / minimum type decision.
verm button: shows total of cash plus shares x last close price in
		simulation.
shrs button: show when shares are bought / sold in simulation.
s. cap input: your start capital at the start of the simulation.
		(a higher start capital leads usually to more gain, due to
		lower transaction costs.

Using the optimize button.
The purpose of this button is to find the optimum values
for the days setting for moving averages (ma1 and ma2).
Example:
Select fund ing<ENTER> in the fund input field (bottom middle).
Then press the optimize button (it will become green).
After a while you will see a text like:
Testing madays1=16 madays2=15 in the top yellow info display.
Best gain= 3.5 at ma1=15 ma2=4 in the bottom yellow info display.
You will see the values increase.
The starting values for the test are the ones in the m.a. 1 and m.a.2 input
field.
The program will try all valid values until you release the optimize button.
It may take a while for the optimize button to release again after you
clicked the mouse on it.
Do NOT click again, or any other buttons during the test.
This is because the optimize routines take a LOT of processing power,
and only occasionally check for pressed buttons, to improve speed.
WARNING:
If you intent to use optimize mode, try running xkra with:
nice -n 19 xkra
that way you will still be able to use other programs.
Optimizing will stop if 1000 days is reached.
this can be changed in xkra.h.
Every time a better value is found, this is copied to the input fields.
When you release the optimize button, these values are written to fund.mva.

Now press the sim button (it will become yellow) in the top left button.
This will enable simulation mode.
In simulation mode, the program will start with the start capital you
entered in input field s.cap, and the do transaction using the method
selected by the button cross / max.
In case cross is selected, the buying and selling will be according to
the gold cross / dead cross method, if max is selected according to the
maximum / minimum method (the latter is just one of my attempt to get better
results).

To see what is happening you can press the shrs (shares) button.
This will draw a reddish line, that is high for the time you posses
the items (shares), and low for the time you do not have any (sold).
If you now also press the verm button, a blue line will indicate the total
value of the cash plus shares value you have at any time.

In the top yellow info display you will see:
shares=3245.00 cash=72.42 tr=74
This indicates at the end (last transaction, present), you have 3245 shares,
72.42 ($?) cash, and 74 transaction (sell plus buy) have taken place.

In the bottom yellow info display you will see:
to_cap=348260.94 gain=3.5
This indicates that the total capital (cash plus shares x last close price)
is now 348260.94 ($?) and your total gain relative to the start of the graph
is 3.5.
The reason I write ($?) is that of cause you could be trading in any
currency.
When buying or selling rates (to the broker) are taken into account.
Also you do not have to be trading shares, it could be kind any item(s).
 
The transaction indicator can show either:
NO ACTON / GOLD CROSS / DEAD CROSS / MAXIMUM / MINIMUM
This indicates what the current state is.


*WINDOW pull down menu*
OPTION CALCULATOR
Selecting 'OPTION CALCULATOR' from the WINDOW pull down menu in the main form
pops up the option calculator form.
This form allows you to see the value of all options that you have .krs
To access the options calculator press the 'options' switch (center left).
The option form will pop up.
For a demo enter the following values:
field description:       data:
fund                    ing
expiration month	oct
expiration year         2000
strike price            55

End press ENTER in each field!
Now you will be shown:
days to expiration
risk free interest rate
current stock price
daily standard deviation
yearly standard deviation
present call value
present put value
data points read

This assumes you have the file ing.krs installed /root/stockvac
You can select an other dir by typing the path in the 'Dir' input field.
Changes are saved to disk in the file .xkrarc in your home directory.

Also the interest rate is read from r10j.krs (the 10 year interest). 
You can specify an other filename in the risk free interest file field.

If you supply a fundname that is not present in /root/stockvac, then some
input fields will switch to manual input.
So you do not HAVE to have the .krs files.

Option calculation is done using the Black and Scholes method.
Enter interest rates as .0712 for 7.12 percent.
Deviation as .35 for 35 percent.
Days to expiration is calculated from the computer time up to the third Friday
in the expiration month and expiration year.
See the sources option.c, statistic.c and black_and_scholes.c.
Please note this is all not finished, and there is also a simple command
line option calculator basop on my site and sunsite.
Basop even has a DOS version.

PORTFOLIO MANAGEMENT
Selecting 'PORTFOLIO MANAGEMENT' from the WINDOW pull down menu in the main
form pops up the portfolio management form.
It has a browser that shows all available funds and options you can buy
on the market (the 'market browser').

NOTE:
Values entered in input fields are only accepted after you press either
<ENTER> or <TAB>, or go with the mouse to a different input field.
Else the old value may still be the active value.

Add an option (example):
enter the following:
 in the 'fund' input field enter 'aab' (without the quotes).
 in the 'type' input field enter 'call'.
 in the 'month' input field enter 'nov'.
 in the 'year' input field enter '2000'.
 in the 'strike price' input field enter '22.00'
 press the 'ADD' button.
An entry should now appear in the market browser in black.
The most left field is the quantity you have (zero)
Then follows the combined name of the option.

Add shares:
You only need to enter the fund name in the 'fund' input field,
'stock' in the 'type' input field, then press the 'ADD' button.

Deleting an item:
Select with the left mouse button an entry in the market browser, and press
the 'DELETE' button.
You will be asked for confirmation.

To buy: 
Select an item, enter a price and quantity, and press 'buy'.

To sell: 
Select and item, enter price and quantity, and press 'sell'.

If you sell more then you have, you will go short, the quantity input
field will show a negative value, and a warning may appear.
 
Short positions are shown in red,
long position are shown in dark green,
things you do not own, but can buy or sell are shown in black.

Using the filter:
If you for example only wanted to see the calls aab, then enter
'call aab' in the 'filter keywords' input field.
Now only those items that have both 'call' and 'aab' in the name
will be shown.
You could also have entered 'aab call', the sequence is not important,
but all words in the 'filter keywords' input field MUST be present in
the items name.
Note the complete item name for an option is like:
aab call Nov 1000
for a stock it is simply:
aab
It is possible to use double quotes, for example to discriminate between
aex and aexl.
IIf you only wanted to view aex calls 2000, then enter "aex call" 2000 
The text between the quotes is taken as a literal string, and must match
text in the description.
Spaces are required as separators between two double quoted strings, or a
double quoted string and a not quoted string.

You can make the filtering case sensitive by pressing the 'IGNORE CASE'
button.
Pressing the 'CLR FILTER' button next to the filter keywords input field
clears the filter (and allows everything to be shown).

Sorting:
Normally new entries are added to the end of the list (last line in the market
browser).
If you want to sort alphabetically, press the 'SORT ALPHA' button.
Sorting may take a while if there are a lot of entries, and you have a slow
processor.
 
The 'Account' input field:
This holds what you have in your bank account (or cash), it will be
decremented by buying, selling will increment it.

The 'Value' input field:
This is not really an input, but shows the calculated value of what you own.
When filter is active, only that what is shown is used in the calculation!!
This allows you to simply see the value of an entry or group of entries.

The 'SHOW ALL' / 'SHOW OWNED' button:
If pressed, only items you actually have (more the 0 off) are displayed.
This has no influence on the portfolio value calculation, only shortens the
list of items displayed, so it is more convenient to browse around in.

The 'IMPORT' pull down menu.
This allows you to read in shares or option series in the Davieff format
(follow the link at www.beurs.nl/download/, this leads to quoteweb), or use
the utility update_funds -g to get the data.

Enter the full path filename, or use the browser to get the file.
After a little while the new items should appear in the browser.

You can also choose to read in email from fastservice, the email
address is "stock robot" <stocks@fastservice.com>
They have free email sercie you can subscribe to at:
http://browse.to/stockservice
Even if there are several emails present form fastservice and others in
your mailbox, xkra will automatically update using the last one.
You can specify any user for the mail, so to prevent mail from fastservice
piling up in your normal account, that you use for correspondence, you
could create a special user for fastservice, and keep the data there for
reference perhaps. (xkra does not delete mails it processed).
You must however always specify a name in ~/.xkra/setup/fastservice_mail_name
And this name must be of an existing user on your server.
Then when you subscribe to fastservice, enter that users name.

The CHARTS pull down menu
If you select 'WHERE YOUR MONEY IS' from you will get a pie chart showing
the value of the options you have, your account, and the value of the shares
you have.
Colors that have red in it (for example yellow is red plus green) indicate
negative values, the values are also printed an numbers. 
Selecting 'HIDE CHARTS' will hide the chart again.
Because of some xforms bug the text in the pie chart may also appear in the
portfolio browser, and will not be erased by 'hide charts'.

The UPDATE pull down menu:
Selecting 'UPDATE .krs FILES FROM PORTFOLIO appends' the close prices to the
.krs files from the values in the portfolio browser, (you should have gotten
recent data first).
Selecting 'UPDATE .krs FILES FROM FASTSERVICE EMAILS' updates the .krs files
from the fastservice emails received in your name (the user).
If you select this option for a second time, nothing will happen, unless new
mail(s) came in.
xkra uses the time indicated in the Subject line of the email, so double entries
should not be possible.

So it would be possibe to go on holiday, then when you come back just select
this option, and all your .krs files (only the ones in fastservice.dat) would
be updated correctly for the whole period you were away.

The 'DEL EXPIRED' button.
Pressing this button causes xkra to delete any expired entries.
Calculating the exact expiration day for each entry takes time, so progress
is shown in the status field as a percentage of the entries examined.

The '-' and '+' buttons:
These will change the fontsize in the market browser, so you can adapt it
to your screen size and viewing distance etc..

The 'ACCEPT' button:
This will save all market browser entries to disk, also the 'Account' value,
Value, fontsizes selected.

Data is saved in the file ~/stockvac/items.dat, with a backup in items.dat~,
where 'stockvac' is the default directory, or else the directory entered in
'Dir' in the main form is used.
So it is possible to have more then one items.dat.
Editing these files is not recommended.

The 'CANCEL' button:
This will reread the data from the file items.dat, and then close the portfolio form.
Any changes you made since the last time will be lost.

The 'MARKET / TRANSACTIONS button:
Pressing this button while in the market browser, shows the transaction
browser.

The layout of the form is totally different.
You can still use the filter, different key words then in the market browser
are allowed (and retained in one session).

This browser contains a list of all transactions done, sorted by date.
The most recent ones are at the bottom of the list.

You can use the filter functions in the same way as in the market browser.

Transactions that resulted in long positions are shown in dark green, the ones
that resulted in short positions are shown in in red.
Transactions that resulted in all sold, are shown in black.

It is possible to delete an item (using the 'DELETE" button, BUT NOT
RECOMMENDED, since this falsifies the history log that this browser
represents.

The 'ADD TR." button.
Pushing this button pops up a form.
This form allows you to enter transactions on any date in the transaction
list.

*NOTE*
 Before you add any transactions in the transaction browser using this
 button, make an entry for that item in the market browser.
 If you do not have an entry, an error alert will pop up when you press
 accept in this form. If this happens, press CANCEL, make the entry,
 then press ADD TR again, followed by ACCEPT.

In the top of the form enter the year, month, day of month the transaction
took place.
In the bottom fields enter the fund (for example aex), type (stock put call).
In case of a call or put also enter the expiration year, expiration month, and
strike price.
You have to enter something in the Quantity and Price input fields,
and press the BUY or SELL button.
For example you buy 100 (quantity) at 33.20 (price).
Finally pressing accept will make the entry and bring you back in the
transaction browser.
The 'CLEAR' button will clear all input fields.
Fields will be saved, so when you press ADD TR again, they will still be there,
but leaving the program and restarting it will clear the fields again.

Please note that NO action you did is permanent UNTIL you pressed ACCEPT
in the PORTFOLIO / MARKET browser.

Use this with care, for example only for corrections.
If you add a transaction for a fund that does not exist yet, an entry will be
generated in the market browser as well.

Data is saved in the file ~/transactions/transactions.dat, with a backup in
transactions.dat~, where 'stockvac' is the default directory, or else the
directory entered in 'Dir' in the main form is used.
So it is possible to have more then one transactions.dat.
Editing these files is not recommended.


SHARES RATES
The share rates form:
Selecting 'SHARE RATES' from the WINDOW pull down menu in the main form:
pops up the share rates form.
This form allows you to enter the rates your bank or broker uses for
share transactions.

WINDOW pull down menu
SHARE RATES selection:
Pops up a form.
		Fill in the rates for buying and selling (transaction cost)
		for each fund, needed in simulation, the program will
		ask for these if not specified, by popping up a form.
		These rates are kept in the file share_rates.dat, in the
		same directory you keep the fund.krs files.
Using the rates form:
Example:
buy                            sell
minimum 10                     minimum 20
from 0$      value .65%        from 0$     value .65%
from 100$    value  .4%        from 100$   value  .4%
from 1000$   value  .3%        from 1000$  value  .3%
fixed 20$                      fixed 15%      
currency $

The left side is buying, the right side selling.
This indicates that there is a minimum transaction cost of 10$.
The cost is .65% per transaction for amounts < 100$,
.4% per transaction for amounts < 1000$, and .3% per transaction
for amounts 1000$ or more.
There also is a fixed rate of 20$, and a minimum rate of 10$

Empty fields are ignored, but the first from 0$ is required.

The % sign is allowed (after the value) to indicate percentage.
if you were to write for example .65$, the calculation
will be .65$ for every transaction below 100$.
If you do not use the $ sign in 'from', then the quantity is used,
else the value (close price * shares) is used.
Note I am still experimenting with this.
Currency can be anything, try E for euro, but you could also write Euro:
from 0Euro value .65%
from 1000Euro value .4%
currency Euro
If you use $ in one from field, you must do it in all, else a warning
will pop up.
The same for the value fields.


OPTION RATES
The share rates form:
Selecting 'OPTION RATES' from the WINDOW pull down menu in the main form:
pops up the option rates form.
This form allows you to enter the rates your bank or broker uses for
option transactions.
Usage is similar to the SHARES RATES form.


OPTION EVALUATION
The options evaluation form.
Selecting 'OPTION EVALUATION' from the WINDOW pull down menu in the main form:
pops up the option evaluation form.
This form allows you to see the value of all options that you have .krs
files for, as compared to the strike price in percentage.
At this moment this form only allows import of option data in Davieff format.
Select 'Import DAVIEFF OPTIONS' from the IMPORT menu on this form.
You will be asked for confirmation, since old data present will be cleared.
Now a file browser will pop up.
Enter the path and filename to the DAvieff xxxxxxxx.CSV file, where the xxx's
stand for the current date.
The current date is already entered for you, if you want an older file,
just modify it.
You can also use the file browser to select a file.
Pressing 'Ready' in the file browser will start the calculation.
Progress is shown in the status bar at the bottom of the form.
Calculation may take several minutes, especially on a slower PC.
Again, only those entries in the Davieff file that there are .krs files for,
are processed, because the historical .krs data is needed to calculate
the yearly standard deviation and to et the close price.
Once calculation is finished, you can use the filter the same way as in the
other browsers to make a selection of what you want to see.
For example entering 'call ing 1999' (without the quotes) in the filter
input field shows all calls ING 1999.
*end WINDOW pull down menu in main form*


NEW YORK CLOCK
Setting the time difference for the New York clock:
The value in the in the file ~/.xkra/setup/new_york_time_diff
holds the offset in hours, the value can be positive or negative.
To change exit xkra first (else it will write old values on exit), then
use an editor to make the change.
Finally restart xkra.


* The following files must NOT be edited by hand, unless specifically mentioned,
* as these are computer generated
Files by default in ~/stockvac/:
For a fund named fund:
fund_list.dat		list of funds that you have .krs files for
			and want to evaluate in the option evaluation form.
			This file must be manually edited.	
			Fundname (abbreviations) must be in lower case, one per line,
			lines starting with # are ignored.
fastservice.dat		holds the fund names as used by fastservice mail
			together with the normal ticker symbol, separated
			by a comma.
			If no ticker symbol (and comma) is present after
			the name, the fund name is scipped.
fund.krs		file holds close price and other data for a fund

			my format.
fund.csv		comma separated format file format.
fund.mva		moving average settings and relative file for
			relative strength for a fund.
share_rates.dat		buy / sell rates shares (share rates form).
option_rates.dat	buy / sell rates options (option rates form).
options.dat		list of evaluated options.
items.dat		list of items in portfolio.
transactions.dat	list of transactions done.

files by default in ~/.xkra/setup/
fontsizes		fontsizes for the various forms.

new_york_offset		offset in hours NewYork clock
			This file can be edited.

stock_directory		Directory where other data files are kept, default
			is ~/stockvac

fastservice_krs_time    last update time krs files from fastservice email
                        seconds since 1900
fastservice_time        time of last fastservice email processed seconds since 1900
fastservice_mail_name   name uf user that receives the fastservice email,
                        this must be an existing user on your system.
                        the file /var/spool/mail/user.. is read.
                        mails read are not deleted.
THE KRS FILE FORMAT
The .krs file format is developed by me.
Its purpose is to have files that are short, hold Teletext (Videotext,
Ceefax) page, row, and column, so update from that medium is possible.
A serial format is used for the year, month, and ex dividend events.

Field		function

1			year as a string (1998)
2			month (first 3 characters, Dutch).
3			day of month ( 1 to 31).
4			fund name as it appears in TELETEXT (or CEEFAX or whatever).
5			trend, 0=no trend (horizontal), < 0 bearish, > 0 Bullish),
6			preferred acquisition circuit (and display memory) for saa chip
			 (0 to 3).
7			teletext page where stock value is supposed to be.
8			teletext sub page where stock value is supposed to be.
9			horizontal position of stock value on teletext page.
10			vertical position of stock value on teletext page.
11			field width of stock value on teletext page.
12			maximum possible value for stock (for input check via teletext).
13			minimum possible value for stock (for input check via teletext).
14			significant digits in fraction of stock value on teletext screen
			 (so for example in 122.55 it is 2).
From here on stock values, with the following exceptions:
Any negative value announces a 'special field' (not containing a stock value).
So far implemented:
-1			month follows in the form of a text field, printed under the stock
			 graph as the x axis (example -1 Jul). 
-2			comment follows in the form of a text field, printed at a fixed
			 distance above the stock graph, now used for exdivident+day of
			 month this happened. (example  -2 X26 )
-3			year (example  -3 1999 ) 
-4			split (example  -4 split0.45 )

New reserved (n can be float, some funds allow you to buy part of a share):
-5			bought n shares	 (example -5 100.01).
-6			sold n shares	 (example -6 55.20).
-7			bought n options n/type/month/year/strike_price/price
				(example -7 12/call/oct/2004/20.50/7.30).
-8			sold n options	 n/type/month/year/strike_price/price
				(example -8 11/put/oct/2003/12.00/4.50). 
-9			paid dividend	 (example -9 2.10)
-10			volume		 (example -10 30001).

The possibilities of this system are rather limitless.

EVERY entry ends with a space.
There must always at least be ONE close price between to special entries.
*
I will try to drop this requirement in future releases, some code
modifications are needed for this, also in supporting programs.
*

others		free to be used (reserved for future use).


Special thanks:
This code is based on the description of the Black and Scholes option
calculation model as described in the book 'Futures and Options' by
Professor Franklin R Edwards and Cindy W Ma.
Special thanks to them and also to the following people:
Geert Jansen for inspiring me to actually write the code,
Guru Maharaji for making my life so beautiful.
 
