/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "xkra.h"

FD_xkra *fd_main_form;
extern FD_xkra *fdui;

int main(int argc, char *argv[])
{
int a, i;
int n;
char temp[256];
struct passwd *userinfo;

FL_IOPT fl_iopt;
    
debug_flag = 0;
if(argc > 2) debug_flag = 1;

/* against flashing */
/* set double buffering */
fl_iopt.doubleBuffer = 1;
fl_set_defaults(FL_PDDouble, &fl_iopt);
                   
/* get user info */
userinfo = getpwuid(getuid() );

/* get home directory */ 
home_dir = strsave(userinfo -> pw_dir);
if(! home_dir)
	{
	fprintf(stdout, "main(): cannot allocte space for home_dir\n");
	exit(1);
	}
user_name = strsave(userinfo -> pw_name);
if(! user_name)
	{
	fprintf(stdout, "main(): cannot allocate space for user_name\n");
	exit(1);
	}

fl_initialize(&argc, argv, 0, 0, 0);
fd_main_form = create_form_main_form();

/* fill-in form initialization code */

/* show the first form */

fl_show_form(\
fd_main_form -> main_form, FL_PLACE_FREE, FL_FULLBORDER, VERSION);

/* print the (default) in the input fields */

/* set default file name for riskfree interest (extention .krs is added */
fl_set_input(fdui -> option_calculator_form_riskfree_interest_file_input_field, "r10j");

maday1 = 1;/* moving average 1 (days) */
maday2 = 1;/* moving average 2 (days) */
close_flag = 1;/* plot close prices */

strcpy(file_path, home_dir);
strcat(file_path, "/stockvac/");
strcpy(file_type,"krs");
strcpy(relative_filename, "dia");/* all relatives to this */

momentum_days = 10;/* days for momentum calculation */
start_capital = 1000;
decision_methode = GOLD_DEAD;

sprintf(temp, "%d", start);
fl_set_input(fd_main_form -> start_input, temp);
/* Note: end is set after a file is loaded and in end_input_cb */
fl_set_input(fd_main_form -> end_input, "end");

sprintf(temp, "%d", maday1);
fl_set_input(fd_main_form -> ma1_input, temp);
sprintf(temp, "%d", maday2);
fl_set_input(fd_main_form -> ma2_input, temp);

sprintf(temp, "%f", mawei1);
fl_set_input(fd_main_form -> mawei1_input, temp);
sprintf(temp, "%f", mawei2);
fl_set_input(fd_main_form -> mawei2_input, temp);

sprintf(temp, "%d", ma1_lead_days);
fl_set_input(fd_main_form -> ma1_lead_input, temp);
sprintf(temp, "%d", ma2_lead_days);
fl_set_input(fd_main_form -> ma2_lead_input, temp);

fl_set_input(fd_main_form -> relative_file_input, relative_filename);

sprintf(temp, "%d", momentum_days);
fl_set_input(fd_main_form -> momentum_days_input, temp);

sprintf(temp, "%4.2f", start_capital);
fl_set_input(fd_main_form -> start_capital_input, temp);

/* get default directory */
if(! load_global_settings() )
	{
/*
	fl_show_alert(\
	"Cannot read all global settings", "", "using defaults", 1);
*/
	}
/*
signal(SIGALRM, print_new_york_time);
alarm(1);
*/

fl_do_forms();

return(0);
}
