#ifndef _XKRA_PROTO_H_
#define _XKRA_PROTO_H_

extern int parse_fastservice_shares_email_and_update_krs_files(\
	char *text, int monthday, int month, int year);
extern int parse_all_fastservice_shares_emails_and_update_krs_files();
extern update_krs_files_from_fastservice_email();
extern int update_fund_file(\
	char *fundname, float close_price, long volume,\
	int monthday, int month, int year);
extern int update_csv_csw(\
	char *filebody, int year, int month, int mtday,\
	float closeprice, long volume,\
	int volume_flag);
extern int update_krs_file(\
	char *fundname, float close_price, long volume,\
	int htm_file_year, int htm_file_month, int htm_file_day_of_month,\
	int data_type);
extern void portfolio_form_update_menu_cb(FL_OBJECT *ob, long data);
extern int update_krs_files_from_portfolio();
extern int load_fsfunds();
extern int save_fsfunds();
extern int hash(char *s);
extern int fshash(char * s);
extern struct fsfund *lookup_fsfund(char *name);
extern struct fsfund *install_fsfund(char *name);
extern int delete_all_fsfunds();
extern struct mail *lookup_mail(char *name);
extern struct mail *install_mail_at_end_of_list(char *name);
extern int delete_all_mails();
extern int load_incoming_mail(int *messages);
extern int check_mail_local();
extern int parse_fastservice_shares_email(char *text);
extern int import_fastservice_files();
extern int add_fastservice_shares_to_notering_list();
extern void portfolio_form_chart_menu_cb(FL_OBJECT *ob, long data);
extern void option_evaluation_form_fontsize_up_button_cb(\
	FL_OBJECT *ob, long data);
	extern void option_evaluation_form_fontsize_down_button_cb(\
	FL_OBJECT *ob, long data);
extern int new_option_calculation();
extern int month_to_digit(char *month);
extern int get_current_value(char *filename, float *current_value);
extern int load_stock_prices(char *filename, float *data, int *data_points);
extern int calculate_option_price_fast(\
	char *fundname,\
	char *expiration_month,\
	char *expiration_year,\
	char *strike_price,\
	float *days_to_expiration,\
	float *current_riskfree_interest_rate,\
	float *current_stock_price,\
	float *daily_standard_deviation,\
	double *yearly_standard_deviation,\
	float *present_call_value,\
	float *present_put_value\
	);
extern int calculate_option_price(\
	char *fundname,\
	char *expiration_month,\
	char *expiration_year,\
	char *strike_price,\
	float *days_to_expiration,\
	float *current_riskfree_interest_rate,\
	float *current_stock_price,\
	float *daily_standard_deviation,\
	double *yearly_standard_deviation,\
	float *present_call_value,\
	float *present_put_value\
	);
extern int ogettime(
	char *weekday,
	char *month,
	int *monthday,
	int *hour,
	int *minute,
	int *second,
	int *year
	);
extern int save_options();
extern int load_options();
extern int add_option_to_database(\
	char *option_name, float strike_price, int type, int month, int year,\
	float current_option_price, int quantity, float days_to_expiration,\
	float current_stock_price,\
	float current_call_value, float current_put_value, float percentage);
extern int fill_stock_list(char *filename);
extern int import_and_evaluate_davieff_options_file();
extern int parse_davieff_option_file_for_evaluation(char *filename);
extern int show_option_evaluation_form();
extern int show_options(int position);
extern int import_and_evaluate_davieff_options_file();
extern void option_evaluation_form_import_menu_cb(FL_OBJECT *ob, long data);
extern void option_evaluation_form_filter_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void option_evaluation_form_filter_case_button_cb(\
	FL_OBJECT *ob, long data);
extern void option_evaluation_form_filter_clear_button_cb(\
	FL_OBJECT *ob, long data);
extern int show_option_evaluation_form();
extern void option_evaluation_form_option_browser_cb(\
	FL_OBJECT *ob, long data);
extern void option_evaluation_form_option_browser_double_cb(\
	FL_OBJECT *ob, long data);
extern void option_evaluation_form_cancel_button_cb(\
	FL_OBJECT *ob, long data);
extern void option_evaluation_form_accept_button_cb(\
	FL_OBJECT *ob, long data);
extern void main_form_window_menu_cb(FL_OBJECT *ob, long data);
extern void portfolio_form_delete_expired_button_cb(\
	FL_OBJECT *ob, long data);
extern int get_days_to_expiration(\
	char *expiration_month, char *expiration_year,\
	float *days_to_expiration);
extern int get_days_to_expiration2(\
	int expiration_month, int expiration_year, float *days_to_expiration);
extern int delete_expired_options();
extern int set_item_price(char *item, float price);
extern int load_new_york_offset();
extern int save_new_york_offset();
extern void portfolio_form_import_menu_cb(FL_OBJECT *ob, long data);
extern char *get_transaction_description(char *name);
extern int mark_if_notering_present_in_list(char *name, int *present);
extern int mark_noteringen_already_present();
extern int modify_and_get_item_quantity(\
	char *item, float *owned_quantity, float quantity);
extern int import_davieff_file(int file_type);
extern int parse_davieff_option_file(char *filename);
extern int parse_daviefff_shares_file(char *filename);
extern int add_transaction_to_transaction_list(\
	int year, int month, int day, int hour, int buy_sell,\
	char *fund, int type, int expiration_month, int expiration_year,\
	float strikeprice, float quantity, float price, float account,\
	char *report);
extern int show_transaction_add_form();
extern void transaction_add_form_account_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void transaction_add_form_year_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void transaction_add_form_month_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void transaction_add_form_day_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void transaction_add_form_hour_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void transaction_add_form_fund_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void transaction_add_form_type_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void transaction_add_form_expiration_month_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void transaction_add_form_expiration_year_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void transaction_add_form_strikeprice_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void transaction_add_form_quantity_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void transaction_add_form_price_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void transaction_add_form_buy_button_cb(FL_OBJECT *ob, long data);
extern void transaction_add_form_sell_button_cb(FL_OBJECT *ob, long data);
extern void transaction_add_form_clear_button_cb(FL_OBJECT *ob, long data);
extern void transaction_add_form_add_transaction_button_cb(\
	FL_OBJECT *ob, long data);
extern void transaction_add_form_cancel_button_cb(\
	FL_OBJECT *ob, long data);
extern void transaction_add_form_accept_button_cb(\
	FL_OBJECT *ob, long data);
extern int test_for_open_forms(int *some_form_open_flag);
extern int update_and_get_owned_quantity(\
	char *item, float *owned_quantity, float quantity);
extern struct transaction *lookup_transaction(char *name);
extern struct transaction *install_transaction_at_end_of_list(char *name);
extern int delete_transaction(char *name);
extern int delete_all_transactions();
extern int swap_transaction_position(\
	struct transaction *ptop, struct transaction *pbottom);
extern int load_transactions();
extern int save_transactions();
extern int show_transactions(int position);
extern char *line_to_transaction(int line);
extern int transaction_to_line(char *url, int *line);
extern int add_transaction_to_portfolio(\
	time_t transaction_time, char *item, float quantity, float price,\
	int buy_sell, float account);
extern int sort_transactions(int mode);
extern int select_portfolio_form_browser(int browser);
extern char *strcasestr(char *str1, char *str2);
extern int calculate_portfolio_value(\
	float *value, float *account_value,\
	float *shares_value, float *options_value);
extern int buy_item(char *name, float quantity, float price);
extern int sell_item(char *name, float quantity, float price);
extern char *digit_to_month(int month);
extern int add_item_to_portfolio(char *fund, int type, int month, int year,\
	float strikeprice, int test_exists, float transaction_price);
extern int modify_portfolio_item_price(char *fund, int type, int month,\
	int year, float strikeprice, float transaction_price);
extern void portfolio_form_value_input_field_cb(FL_OBJECT *ob, long data);
extern void portfolio_form_cash_input_field_cb(FL_OBJECT *ob, long data);
extern void portfolio_form_market_filter_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void portfolio_form_market_filter_case_button_cb(\
	FL_OBJECT *ob, long data);
extern void portfolio_form_market_filter_clear_button_cb(\
	FL_OBJECT *ob, long data);
extern void portfolio_form_transaction_filter_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void portfolio_form_transaction_filter_case_button_cb(\
	FL_OBJECT *ob, long data);
extern void portfolio_form_transaction_filter_clear_button_cb(\
	FL_OBJECT *ob, long data);
extern void portfolio_form_show_owned_only_button_cb(\
	FL_OBJECT *ob, long data);
extern void portfolio_form_market_browser_cb(FL_OBJECT *ob, long data);
extern void portfolio_form_market_browser_double_cb(\
	FL_OBJECT *ob, long data);
extern void portfolio_form_transaction_browser_cb(FL_OBJECT *ob, long data);
extern void portfolio_form_transaction_browser_double_cb(\
	FL_OBJECT *ob, long data);
extern void portfolio_form_browser_select_button_cb(\
	FL_OBJECT *ob, long data);
extern void portfolio_form_sort_alpha_button_cb(FL_OBJECT *ob, long data);
extern void portfolio_form_sort_price_button_cb(FL_OBJECT *ob, long data);
extern void portfolio_form_price_input_field_cb(FL_OBJECT *ob, long data);
extern void portfolio_form_sell_button_cb(FL_OBJECT *ob, long data);
extern void portfolio_form_buy_button_cb(FL_OBJECT *ob, long data);
extern void portfolio_form_delete_item_button_cb(FL_OBJECT *ob, long data);
extern void portfolio_form_delete_transaction_button_cb(\
	FL_OBJECT *ob, long data);
extern void portfolio_form_clear_button_cb(FL_OBJECT *ob, long data);
extern void portfolio_form_add_item_button_cb(FL_OBJECT *ob, long data);
extern void portfolio_form_add_transaction_button_cb(\
	FL_OBJECT *ob, long data);
extern void portfolio_form_quantity_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void portfolio_form_fund_input_field_cb(FL_OBJECT *ob, long data);
extern void portfolio_form_type_input_field_cb(FL_OBJECT *ob, long data);
extern void portfolio_form_month_input_field_cb(FL_OBJECT *ob, long data);
extern void portfolio_form_year_input_field_cb(FL_OBJECT *ob, long data);
extern void portfolio_form_strikeprice_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void portfolio_form_market_group_fontsize_up_button_cb(\
	FL_OBJECT *ob, long data);
extern void portfolio_form_market_group_fontsize_down_button_cb(\
	FL_OBJECT *ob, long data);
extern void portfolio_form_transaction_group_fontsize_up_button_cb(\
	FL_OBJECT *ob, long data);
extern void portfolio_form_transaction_group_fontsize_down_button_cb(\
	FL_OBJECT *ob, long data);
extern void portfolio_form_accept_button_cb(FL_OBJECT *ob, long data);
extern void portfolio_form_cancel_button_cb(FL_OBJECT *ob, long data);
extern void portfolio_switch_cb(FL_OBJECT *ob, long data);
extern int load_global_settings();
extern int save_global_settings();
extern int save_setting(char *type, char *string);
extern char *load_setting(char *type);
extern int save_fontsizes();
extern int load_fontsizes();
extern int save_stock_directory_setting();
extern int load_stock_directory_setting();
extern struct item *lookup_item(char *name);
extern struct item *install_item_at_end_of_list(char *name);
extern int sort_items(int mode);
extern int swap_item_position(struct item *ptop, struct item *pbottom);
extern int delete_item(char *name);
extern int delete_all_items();
extern int load_items();
extern int save_items();
extern int show_portfolio_form();
extern int item_to_line(char *url, int *line);
extern int show_items(int position);
extern char *line_to_item(int line);
extern void replace(char *text, char *string, char *replace, char *result);
extern int set_item_status(char *item, int status);
extern int get_item_status(char *item, int *status);
extern int set_item_update_time(char *item_in_progress, time_t now);
extern int integer_to_fontsize(int fontsize);
extern void directory_input_cb(FL_OBJECT *ob, long data);
extern void option_calculator_form_fundname_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void option_calculator_form_month_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void option_calculator_form_year_input_field_cb(FL_OBJECT *ob, long data);
extern void option_calculator_form_strike_price_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void option_calculator_form_days_to_expiration_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void option_calculator_form_days_to_expiration_button_cb(\
	FL_OBJECT *ob, long data);
extern void option_calculator_form_current_riskfree_interest_rate_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void option_calculator_form_current_riskfree_interest_rate_button_cb(\
	FL_OBJECT *ob, long data);
extern void option_calculator_form_riskfree_interest_file_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void option_calculator_form_current_stock_price_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void option_calculator_form_current_stock_price_button_cb(\
	FL_OBJECT *ob, long data);
extern void option_calculator_form_daily_standard_deviation_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void option_calculator_form_daily_standard_deviation_button_cb(\
	FL_OBJECT *ob, long data);
extern void option_calculator_form_data_points_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void option_calculator_form_yearly_standard_deviation_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void option_calculator_form_yearly_standard_deviation_button_cb(\
	FL_OBJECT *ob, long data);
extern void option_calculator_form_present_call_value_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void option_calculator_form_present_put_value_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void option_calculator_form_accept_button_cb(FL_OBJECT *ob, long data);
extern void option_calculator_form_cancel_button_cb(FL_OBJECT *ob, long data);
extern int main(int argc, char **argv);
extern char *strsave(char *s);
extern int buy_sell_simulation(\
	int buy_sell, float share_price, int position);
extern int load_file(int relative_file_flag);
extern print_graph();
extern void file_type_switch_cb(FL_OBJECT *ob, long data);
extern void decision_switch_cb(FL_OBJECT *ob, long data);
extern void exit_switch_cb(FL_OBJECT *ob, long data);
extern void close_switch_cb(FL_OBJECT *ob, long data);
extern void shares_switch_cb(FL_OBJECT *ob, long data);
extern void vermogen_switch_cb(FL_OBJECT *ob, long data);
extern void relative_switch_cb(FL_OBJECT *ob, long data);
extern void momentum_switch_cb(FL_OBJECT *ob, long data);
extern void update_switch_cb(FL_OBJECT *ob, long data);
extern void auto_trade_switch_cb(FL_OBJECT *ob, long data);
extern void simulation_switch_cb(FL_OBJECT *ob, long data);
extern void volume_switch_cb(FL_OBJECT *ob, long data);
extern void ma1_switch_cb(FL_OBJECT *ob, long data);
extern void ma2_switch_cb(FL_OBJECT *ob, long data);
extern void text_switch_cb(FL_OBJECT *ob, long data);
extern void upper_switch_cb(FL_OBJECT *ob, long data);
extern void lower_switch_cb(FL_OBJECT *ob, long data);
extern void start_input_cb(FL_OBJECT *ob, long data);
extern void end_input_cb(FL_OBJECT *ob, long data);
extern void ma1_input_cb(FL_OBJECT *ob, long data);
extern void ma2_input_cb(FL_OBJECT *ob, long data);
extern void mawei1_input_cb(FL_OBJECT *ob, long data);
extern void mawei2_input_cb(FL_OBJECT *ob, long data);
extern void ma1_lead_input_cb(FL_OBJECT *ob, long data);
extern void ma2_lead_input_cb(FL_OBJECT *ob, long data);
extern void fund_input_cb(FL_OBJECT *ob, long data);
extern void relative_file_input_cb(FL_OBJECT *ob, long data);
extern void momentum_days_input_cb(FL_OBJECT *ob, long data);
extern void start_capital_input_cb(FL_OBJECT *ob, long data);
extern void ixyplotcb(FL_OBJECT *ob, long data);
extern void print_new_york_time(int sig);
extern new_york_time();
extern acquire_data(char *fundname);
extern int autotrade(int crosstype);
extern void optimize_button_cb(FL_OBJECT *ob, long data);
void share_rates_form_buy_minimum_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_buy_from1_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_buy_to1_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_buy_value1_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_buy_from2_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_buy_to2_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_buy_value2_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_buy_from3_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_buy_to3_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_buy_value3_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_buy_from4_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_buy_to4_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_buy_value4_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_buy_fixed_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_sell_minimum_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_sell_from1_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_sell_to1_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_sell_value1_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_sell_from2_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_sell_to2_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_sell_value2_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_sell_from3_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_sell_to3_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_sell_value3_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_sell_from4_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_sell_to4_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_sell_value4_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_sell_fixed_input_field_cb(FL_OBJECT *ob, long data);
void share_rates_form_currency_symbol_input_field_cb(\
	FL_OBJECT *ob, long data);
void share_rates_form_include_button_cb(FL_OBJECT *ob, long data);
void share_rates_form_fontsize_up_button_cb(FL_OBJECT *ob, long data);
void share_rates_form_fontsize_down_button_cb(FL_OBJECT *ob, long data);
void share_rates_form_accept_button_cb(FL_OBJECT *ob, long data);
void share_rates_form_cancel_button_cb(FL_OBJECT *ob, long data);
void option_rates_form_buy_minimum_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_buy_from1_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_buy_to1_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_buy_value1_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_buy_from2_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_buy_to2_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_buy_value2_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_buy_from3_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_buy_to3_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_buy_value3_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_buy_from4_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_buy_to4_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_buy_value4_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_buy_fixed_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_sell_minimum_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_sell_from1_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_sell_to1_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_sell_value1_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_sell_from2_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_sell_to2_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_sell_value2_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_sell_from3_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_sell_to3_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_sell_value3_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_sell_from4_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_sell_to4_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_sell_value4_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_sell_fixed_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_currency_symbol_input_field_cb(FL_OBJECT *ob, long data);
void option_rates_form_include_button_cb(FL_OBJECT *ob, long data);
void option_rates_form_fontsize_up_button_cb(FL_OBJECT *ob, long data);
void option_rates_form_fontsize_down_button_cb(FL_OBJECT *ob, long data);
void option_rates_form_accept_button_cb(FL_OBJECT *ob, long data);
void option_rates_form_cancel_button_cb(FL_OBJECT *ob, long data);
extern int integer_to_fontsize(int fontsize);
extern void rates_switch_cb(FL_OBJECT *ob, long data);
extern int read_rates();
extern int write_rates();
extern int readline(FILE *file, char *contents);
extern int set_rates_variables();
extern int get_share_transaction_cost(\
	int mode, float shares_bought, float share_price,\
	float transaction_price, float *transaction_cost);
extern int get_option_transaction_cost(\
	int mode, float shares_bought, float share_price,\
	float transaction_price, float *transaction_cost);
extern int get_rates_field_type(char *field);
extern int read_settings();
extern int write_settings();

#endif
